<?php
/*
Supasite - web based PHP/mySQL/XML content management tool
Copyright (C) 2001 - Rick

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

/* install.php
 * checks if all variables are configured and creates the tables
 */

### start the HTML for the page ###
echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Strict//EN\" \"http://www.w3.org/TR/html4/strict.dtd\">\n\n";
echo "<html>\n<head>\n\t<title>Supasite Installation</title>\n</head>\n\n";
echo "<body>\n\n<div style=\"display:none\">\n";
echo "<!-- if the supasite tables have not been created yet, these errors are normal.  ignore them. -->\n\n";

#***PUT YOUR SERVER PATH HERE***
require_once("supasite/config.php");

echo "</div>\n\n<div>\n\n"; # end the 'error' DIV

if(!$submit) {
  ### make tables in the db as necessary ###
  $res = $db->list_tables($db->dbname);
  $table_list = array();
  for($i = 0; $i < $db->num_rows($res); $i++) {
    $table_list[$i] = $db->tablename($res, $i);
  }
  if(in_array('settings', $table_list))
    echo "<p>table 'settings' already created.</p>\n\n";
  else
    $new_settings = true;

  if(in_array('usernames', $table_list))
    echo "<p>table 'usernames' already created.</p>\n\n";
  else
    $new_user = true;

  if(in_array('news_topics', $table_list))
    echo "<p>table 'news_topics' already created.</p>\n\n";
  else
    $new_topic = true;

  if(in_array('news', $table_list))
    echo "<p>table 'news' already created.</p>\n\n";
  else
    data_createNewsTable();

  if(in_array('comments', $table_list))
    echo "<p>table 'comments' already created.</p>\n\n";
  else
    data_createCommentsTable();

  ## then, get the variables for the settings table ##
  echo "<form action=\"install.php\" method=\"POST\">\n";

  if($new_settings) {
    echo "<p><b>Site Meta Info</b></p>\n\n";

    echo "<p>&#8226; <b>Site Title:</b>  <input type=\"text\" name=\"title\" /></p>\n\n";

    echo "<p>&#8226; <b>Site Description:</b>  <input type=\"text\" name=\"desc\" /></p>\n\n";

    echo "<p>&#8226; <b>Keywords:</b>  <input type=\"text\" name=\"keywords\" /></p>\n\n";

    echo "<p>&#8226; <b>Main Webmaster:</b>  <input type=\"text\" name=\"webmaster\" /></p>\n\n";

    echo "<p>&#8226; <b>Main Webmaster's Email:</b>  <input type=\"text\" name=\"webmasteremail\" /></p>\n\n";

    echo "<p><b>Site Config</b></p>\n\n";

    echo "<p>&#8226; Number of posts to display on the front page.<br />\n";
    echo "<b>News Age:</b>  <input type=\"text\" name=\"newsage\" value=\"15\"></p>\n\n";

    echo "<p>&#8226; String used to convert the date to a readable format (<i>read about <a href=\"supasite/mysql_date_format.htm\">DATE_FORMAT()</a></i>).<br />\n";
    echo "<b>Date String:</b>  <input type=\"text\" name=\"date_string\" value=\"%W, %M %e, %Y\"> (<i>Monday, June 11, 2001</i>)</p>\n\n";

    echo "<p>&#8226; String used to convert the time to a readable format (<i>read about <a href=\"supasite/mysql_date_format.htm\">DATE_FORMAT()</a></i>).<br />\n";
    echo "<b>Time String:</b>  <input type=\"text\" name=\"time_string\" value=\"%l:%i%p\"> (<i>12:10AM</i>)</p>\n\n";

    echo "<p>&#8226; List of allowable HTML tags that can be entered in the Comments.<br />\n";
    echo "<b>Allowable Tags:</b>  <input type=\"text\" name=\"tags\" value=\"<a>, <i>, <b>, <br>\" style=\"width:300px;\"></p>\n\n";
  }

  if($new_topic) {
    echo "<p>&#8226; Create the main news topic<br />\n";
    echo "<b>News Topic:</b>  <input type=\"text\" name=\"topic_name\" value=\"main\"><br />\n";
  }

  if($new_user) {
    echo "<p><b>User Config</b></p>\n\n";

    echo "<p>&#8226; Create the first super user account for supasite.<br />\n";
    echo "<b>Super User username:</b>  <input type=\"text\" name=\"super_user\"><br />\n";
    echo "<b>Super User password:</b> <input type=\"password\" name=\"super_pass\"></p>\n\n";
  }

  if( ($new_user) || ($new_settings) || ($new_topic) )
    echo "<p><input type=\"submit\" name=\"submit\" value=\"Install\"></p></form>\n\n";
  else
    echo "<p>Supasite installation complete!  Go to the <a href=\"supasite\">admin script</a>.</p>";

} else {
  if( ($super_user != '') || ($super_pass != '') ) {
    data_createUsernamesTable();
    $pass = md5($super_pass);
    $db->run_query("INSERT INTO usernames (username, password, priv) VALUES ('$super_user', '$pass', '1');");
  }

  if($topic_name != '') {
    data_createNewsTopicsTable();
    $db->run_query("INSERT INTO news_topics (topic_name) VALUES ('$topic_name');");
  }

  if($title != '') {
    data_createSettingsTable();
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('meta', 'title', '$title');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('meta', 'desc', '$desc');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('meta', 'keywords', '$keywords');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('meta', 'webmaster', '$webmaster');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('meta', 'webmasterEmail', '$webmasteremail');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('meta', 'copyright', '&copy;');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('meta', 'robots', 'index,follow');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('meta', 'display', '1');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('meta', 'ms', '1');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('meta', 'disable', 'copyright');");

    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('config', 'date_string', '$date_string');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('config', 'time_string', '$time_string');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('config', 'newsage', '$newsage');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('config', 'tags', '$tags');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('config', 'news_script', 'news.php');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('config', 'search_script', 'search.php');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('config', 'build', '0');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('config', 'cache', '0');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('config', 'cache_filename', 'index.html');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('config', 'ping', '0');");

    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('modules', 'modules', 'News:5::Users:5::Settings:2::Comments:0::Database:1');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('modules', 'modules_news', 'add:5::list:5::add_topic:2::list_topics:5::build_cache:5');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('modules', 'modules_users', 'add:2::list:2::profile:5');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('modules', 'modules_settings', 'site:1::meta_tag:1::template:2::server_stats:1');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('modules', 'modules_database', 'manage_modules:1::backup:1::restore:1');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('modules', 'modules_newsFilename', 'admin_news.php');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('modules', 'modules_topicsFilename', 'admin_topics.php');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('modules', 'modules_commentsFilename', 'admin_news.php');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('modules', 'modules_usersFilename', 'admin_users.php');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('modules', 'modules_settingsFilename', 'admin_settings.php');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('modules', 'modules_utilitiesFilename', 'admin_utilities.php');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('modules', 'modules_databaseFilename', 'admin_mods.php');");
    $db->run_query("INSERT INTO settings (type, param, value) VALUES ('modules', 'loaded', '');");
  }
  echo "<p>Supasite installation complete!  Visit the <a href=\"supasite\">admin script</a> and start adding news!</p>";
}

echo "</div>\n</body>\n</html>";

### FUNCTIONS ###
function install_error($var) {
  echo 'The variable $supa['.$var.'] has not been filled in yet.';
  exit;
}

### creates the comments table...
function data_createCommentsTable() {
  global $db;
  $db->run_query("CREATE TABLE comments (
   id int(10) NOT NULL auto_increment,
   root int(10) DEFAULT '0' NOT NULL,
   date date,
   name varchar(30) NOT NULL,
   www varchar(40) NOT NULL,
   comment text NOT NULL,
   PRIMARY KEY (id),
   UNIQUE id (id)
);");
}

### creates the News table...
function data_createNewsTable() {
  global $db;
  $db->run_query("CREATE TABLE news (
   id int(10) NOT NULL auto_increment,
   user_id tinyint(3) unsigned DEFAULT '0' NOT NULL,
   datetime datetime,
   subject varchar(50),
   topic_id tinyint(3) unsigned DEFAULT '1' NOT NULL,
   post text NOT NULL,
   comments tinyint(3) unsigned DEFAULT '0' NOT NULL,
   views smallint(5) unsigned DEFAULT '0' NOT NULL,
   PRIMARY KEY (id)
);");
}

### creates news topics table ###
function data_createNewsTopicsTable() {
  global $db;
  $db->run_query("CREATE TABLE news_topics (
     id tinyint(3) unsigned NOT NULL auto_increment,
     topic_name varchar(20) NOT NULL,
     icon varchar(30),
     PRIMARY KEY (id)
    );");
}

### creates the Usernames table...
function data_createUsernamesTable() {
  global $db;
  $db->run_query("CREATE TABLE usernames (
   id tinyint(3) NOT NULL auto_increment,
   username varchar(30) NOT NULL,
   password varchar(32) NOT NULL,
   priv tinyint(1) DEFAULT '2' NOT NULL,
   email varchar(50) NOT NULL,
   www varchar(100),
   num_posts smallint(5) unsigned,
   last_timestamp datetime,
   PRIMARY KEY (id),
   UNIQUE id (id)
);");
}

function data_createSettingsTable() {
  global $db;
  $db->run_query("CREATE TABLE settings (
     id smallint(3) unsigned NOT NULL auto_increment,
     type varchar(20) NOT NULL,
     param varchar(50) NOT NULL,
     value varchar(150) NOT NULL,
     PRIMARY KEY (id)
      );");
}
?>