<?php
/*
Supasite - web based PHP/mySQL/XML content management tool
Copyright (C) 2001 - Rick Olson (rick@techno-weenie.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

SCRIPT NAME:  search.php
DESC:  queries the database and presents its results
*/

require_once("supasite/config.php");
require_once("$supa[include_path]/backend_site.php");
require_once("$supa[include_path]/site_news.php");
$templates = new templates_xml();

/* if no query string, show the advanced search form */
if(!$HTTP_GET_VARS) {

  $content = show_search_form();

} else {
  $p = $HTTP_GET_VARS[p];
  if($p < 1)
    $p = 1;

  if($r < 1)
    $r = $site[newsage];

  if($HTTP_GET_VARS['type'] == 'adv') {
    if(!$d)
      $d = parse_query_date($d_year, $d_month, $d_day);
    $res =  backend_advSearch($q, $w, $t, $u, $d, $sort, $r, $p);
    $query_status = "Your search of \"$q\"";
  } else {
    $res = backend_simpleSearch($q);
    $query_status = "Your search of \"$q\"";
  }

  if($HTTP_GET_VARS['debug_sql'] == 1)
    echo "\n<!--\n$res[query]\n-->\n";
  $res_count = $res[results];

  ### forming query sentence ###

  ### if no results...
  if($res_count == 0) {
    $content = show_search_form("$query_status returned no results.");

  ### if results are returned
  } else {
    if(!$pages)
      $pages = ceil($res_count / $r);
    if($res_count != 1)      $r_s = 's';
    if($pages != 1)           $p_s = 's';

    if((!$p) || ($p == 1)) {
      $content = common_status("$query_status returned $res_count result$r_s ($pages page$p_s).");
    } else {
      $content = common_status("Viewing $res_count result$r_s on page $p of $pages for your search of \"$q\".");
    }

    $content .= build_search_arrows($pages, $p);

    $i = 0;
    /* for each result, print it in the HTML form  */
    while( (list($null, $row) = each($res)) && ($i < $r) ) {
      if(is_array($row)) {
        $content .= news_printNews($row);
        $i++;
      }
    }

    $content .= build_search_arrows($pages, $p);
  }
}

### fill the template with the file's contents
echo $templates->fill_template($content);

function parse_query_date($year, $month, $day) {
  if($year == 'yyyy')          $year = '____';
  if($month == 'mm')         $month = '__';
  if($day == 'dd')               $day = '__';
  $date = "$year-$month-$day";
  return $date;
}

/* FUNCTIONS */
function build_search_arrows($pages, $current_page) {
  global $SCRIPT_NAME, $q, $w, $t, $u, $d, $r, $sort;
  if($w == '')
    $w = 'any';

  $prev = "&lt;&lt;-- prev";
  $next = "next --&gt;&gt;";

  /* showing PREV arrow */
  if($current_page > 1) {
    $prev_page = $current_page - 1;
    $prev = "<a href=\"$SCRIPT_NAME?q=$q&amp;w=$w&amp;t=$t&amp;u=$u&amp;d=$d&amp;r=$r&amp;sort=$sort&amp;p=$prev_page&amp;pages=$pages&amp;type=adv\">$prev</a>";
  }

  /* showing NEXT arrow */
  if(($current_page < $pages) && ($pages != 1)) {
    $next_page = $current_page + 1;
    $next = "<a href=\"$SCRIPT_NAME?q=$q&amp;w=$w&amp;t=$t&amp;u=$u&amp;d=$d&amp;r=$r&amp;sort=$sort&amp;p=$next_page&amp;pages=$pages&amp;type=adv\">$next</a>";
  }

  if(($prev_page) || ($next_page))
    return "<p class=\"arrow\">$prev | $next</p>\n\n";
}

function show_search_form($msg = '') {
  if($msg != '')
    $content = common_status($msg);

  ### get an array of all years that have been posted ###
  global $site, $supa;
  $years = data_getYears();

  ### get an array of months  ###
  $months['01'] = 'Jan';
  $months['02'] = 'Feb';
  $months['03'] = 'Mar';
  $months['04'] = 'Apr';
  $months['05'] = 'May';
  $months['06'] = 'Jun';
  $months['07'] = 'Jul';
  $months['08'] = 'Aug';
  $months['09'] = 'Sep';
  $months['10'] = 'Oct';
  $months['11'] = 'Nov';
  $months['12'] = 'Dec';

  $content .= "<form action=\"$supa[web_path]/search.php\" method=\"GET\">\n";
  $content .= "<table>\n\n  <tr><td>\n";
  $content .= "    <b>Search String:</b>\n";
  $content .= "  </td><td>\n";
  $content .= "    <input type=\"text\" name=\"q\" />\n";
  $content .= "  </td></tr>\n\n";

  $content .= "  <tr><td>\n";
  $content .= "  </td><td>\n";
  $content .= "    <p class=\"small\"><input type=\"radio\" name=\"w\" value=\"any\" checked=\"checked\" /> - ANY\n";
  $content .= "    <input type=\"radio\" name=\"w\" value=\"all\" /> - ALL<br />\n";
  $content .= "    <input type=\"radio\" name=\"w\" value=\"exact\" /> - EXACT PHRASE</p>\n";
  $content .= "  </td></tr>\n\n";

  $content .= "  <tr><td>\n";
  $content .= "  </td><td>\n";
  ### make topic list ###
  $t_arr = data_getTopicList();
  foreach($t_arr as $k=>$v) {
    $topic_list .= "      <option value=\"$k\">$v</option>\n";
  }
  $content .= "    <select name=\"t\">\n  <option value=\"0\">by Topic</option>\n$topic_list    </select>\n\n";

  ### make user list ###
  $u_arr = data_getUserList();
  foreach($u_arr as $k=>$v) {
    $user_list .= "      <option value=\"$k\">$v</option>\n";
  }
  $content .= "    -- <select name=\"u\">\n  <option value=\"0\">by User</option>\n$user_list    </select>\n\n";
  $content .= "  </td></tr>\n\n";

  $content .= "  <tr><td>\n";
  $content .= "    <b>by Date:</b>\n";
  $content .= "  </td><td>\n";
  $content .= "    <p><select name=\"d_year\">\n";
  $content .= "      <option value=\"yyyy\">yyyy</option>\n";
  foreach($years as $year) {
    $content .="       <option value=\"$year\">$year</option>\n";
  }
  $content .= "    </select>\n";
  $content .= "    <select name=\"d_month\">\n";
  $content .= "      <option value=\"mm\">mm</option>\n";
  foreach($months as $mnum=>$mname) {
    $content .="       <option value=\"$mnum\">$mname</option>\n";
  }
  $content .= "    </select>\n";
  $content .= "    <select name=\"d_day\">\n";
  $content .= "      <option value=\"dd\">dd</option>\n";
  for($i = 1; $i < 32; $i++) {
    if($i < 10)   $day = '0'.$i;
    else            $day = $i;
    $content .="       <option value=\"$day\">$day</option>\n";
  }
  $content .= "  </td></tr>\n\n";
  $content .= "    </select></p>\n\n";

  $content .= "  <tr><td>\n";
  $content .= "    <b>Sort by Date:</b>\n";
  $content .= "  </td><td>\n";
  $content .= "    <select name=\"sort\">\n";
  $content .= "      <option value=\"DESC\">Descending</option>\n";
  $content .= "      <option value=\"asc\">Ascending</option>\n    </select>\n";
  $content .= "  </td></tr>\n\n";

  $content .= "  <tr><td>\n";
  $content .= "    <b>Results Per Page:</b>\n";
  $content .= "  </td><td>\n";
  $content .= "    <input type=\"text\" name=\"r\" value=\"$site[newsage]\" style=\"width:20px;\" />\n";
  $content .= "  </td></tr>\n\n";
  $content .= "</table>\n\n";

  $content .= "<p><input type=\"hidden\" name=\"type\" value=\"adv\" />\n<input type=\"submit\" name=\"submit\" value=\"search\" /></p>\n";
  $content .= "</form>\n\n";
  return $content;
}
?>