<?php
/*
Supasite - web based PHP/mySQL/XML content management tool
Copyright (C) 2001 - Rick Olson (rick@techno-weenie.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

SCRIPT NAME:  admin_auth_cookies.php (frontend)
DESC:  Handles user authentication using cookies
*/

require_once("$supa[db_path]/$supa[db]_auth.php"); # loads the backend functions

### session stuff ###
if($HTTP_POST_VARS['submit'] == "Log in") {
  $act = auth_createCookie($HTTP_POST_VARS['name'], $HTTP_POST_VARS['passwd'], $HTTP_POST_VARS['settime']);
  if($act == 'good_login')
    $login = auth_login($HTTP_POST_VARS['name'], $HTTP_POST_VARS['passwd']);
}

### if a cookie is present, validate the user
if($HTTP_COOKIE_VARS["user"])
  $login = auth_checkCookie($HTTP_COOKIE_VARS['user']);

### front end functions ###
function supa_bad_login() {
  $supa = &$GLOBALS['supa'];
  $supa["title"] = "Login Invalid";
  $supa["content"] = auth_loginForm("Bad username/password.");
}

function supa_no_priv() {
  $supa = &$GLOBALS['supa'];
  $supa["title"] = "Login Invalid";
  $supa["content"] = auth_loginForm("You do not have the proper privilege to log in here.");
}

function supa_good_login() {
  $supa = &$GLOBALS['supa'];
  $supa["title"] = "Login Valid";
  $supa["content"] = common_status("You've been successfully logged in.");
}

function supa_login() {
  $supa = &$GLOBALS['supa'];
  $GLOBALS['login'] = 0;
  $supa["title"] = "Log In";
  $supa["content"] = auth_loginForm();
}

function supa_logout() {
  auth_deleteCookie();
  $GLOBALS['login'] = 0;

  $supa = &$GLOBALS['supa'];
  $supa["title"] = "Logged Out";
  $supa["content"] = common_status("You've been successfully logged out.");
}

### back end FUNCTIONS ###

### checks the username and password, returns true if it is good or false if it is bad ###
function auth_createCookie($name, $passwd, $settime = 0) {
  global $supa, $act;

  if($settime != 'no')
    $time = time()+604800;
  if($login = auth_login($name, $passwd)) {
    if($login[priv] < 4) {
      $encoded = common_encodeString($name); # encode the username
      $str = common_encodeString("$encoded :: $passwd");
      setcookie("user",$str,$time); # store it in the browser's cookie
      return "good_login";
    } else {
      return "no_priv";
    }
  } else { # no result was returned, so the username or password was BAD
    return "bad_login";
  }
}

function auth_checkCookie($user) {
  $str = common_decodeString($user); # decode username
  list($user, $pass) = explode(' :: ', $str);
  return auth_login(common_decodeString($user), $pass);
}

### deletes a cookie ###
function auth_deleteCookie() {
  setcookie("user","",time()-604800);
}

### prints the login form
function auth_loginForm($msg = '') {
  if($msg != "") { $login_form = common_status($msg); }
  $login_form .= "<form action=\"index.php\" method=\"POST\" name=\"auth_login\">\n";
  $login_form .= "<p>Username: <input type=\"text\" name=\"name\" size=\"40,1\"><br />\n";
  $login_form .= "Password: <input type=\"password\" name=\"passwd\" size=\"40,1\"><br />\n";
  $login_form .= "<input type=\"hidden\" name=\"act\" value=\"login\">\n";
  $login_form .= "<input type=\"SUBMIT\" value=\"Log in\" name=\"submit\" onClick=\"validate_login();\">\n";
  $login_form .= "<input type=\"checkbox\" name=\"settime\" value=\"no\"> don't save persistent cookie?</p>\n";
  $login_form .= "</form>\n\n";
  $login_form .= "<p><b>Cookie Info</b> -- The cookie is required to authenticate your login.  If you click the checkbox, ";
  $login_form .= "the cookie will be set to expire as soon as you end your session (by closing your browser).  Otherwise, ";
  $login_form .= "your cookie will stay active for a week since the last time you were logged in until you explicitly hit log out.</p>\n";
  return $login_form;
}
?>