<?php
/*
Supasite - web based PHP/mySQL/XML content management tool
Copyright (C) 2001 - Rick Olson (rick@techno-weenie.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

SCRIPT NAME:  admin_mods.php (frontend)
DESC:  Manages the mods that are installed with
*/

require_once("$supa[db_path]/$supa[db]_mods.php");
$supa['backup_path'] = "$supa[include_path]/files/backup";
$supa['file_array'] = array( 'supasite.sql', 'news.bak.twml' );
$supa['table_array'] = array( 'news', 'comments', 'news_topics' );
$supa['addon_path'] = "$supa[include_path]/addons";
/* *** SUPA FUNCTIONS *** */

### MOD MANAGER ###
function supa_database_manage_modules() {
  global $login;
  $supa = &$GLOBALS['supa'];
  if($login[priv] <= 2) {
    $supa["title"] = "Managing Supasite Modules";
    $supa["content"] = manage_modules();
  } else {
    $supa["title"] = "Oops";
    $supa["content"] = common_status("You do not have the proper privilege to manage Supasite modules.");
  }
}
function supa_database_install() {
  global $login, $mod;
  $supa = &$GLOBALS['supa'];
  if($login[priv] <= 2) {
    $supa["title"] = "Installing Supasite modules $mod";
    $supa["content"] = module_install($mod);
  } else {
    $supa["title"] = "Oops";
    $supa["content"] = common_status("You do not have the proper privilege to manage Supasite modules.");
  }
}

function supa_database_uninstall() {
  global $login, $mod, $conf;
  $supa = &$GLOBALS['supa'];
  if($login[priv] <= 2) {
    $supa["title"] = "Uninstalling Supasite modules $mod";
    $supa["content"] = module_uninstall($mod, $conf);
  } else {
    $supa["title"] = "Oops";
    $supa["content"] = common_status("You do not have the proper privilege to manage Supasite modules.");
  }
}
### BACKUP/RESTORE SUPA FUNCTIONS ###
function supa_database_backup() {
  global $login;
  $supa = &$GLOBALS['supa'];
  if($login[priv] <= 2) {
    $supa["title"] = "Backup Supasite Data";
    $supa["content"] = backup_form();
  } else {
    $supa["title"] = "Oops";
    $supa["content"] = common_status("You do not have the proper privilege to backup Supasite data.");
  }
}

function supa_database_backing_up() {
  global $login, $HTTP_POST_VARS;
  $supa = &$GLOBALS['supa'];
  if($login[priv] <= 2) {
    $supa["title"] = "Backing up Supasite Data";
    $supa["content"] = backing_up();
  } else {
    $supa["title"] = "Oops";
    $supa["content"] = common_status("You do not have the proper privilege to backup Supasite data.");
  }
}

function supa_database_viewbackup() {
  global $login, $file;
  $supa = &$GLOBALS['supa'];
  if($login[priv] <= 2) {
    $supa["title"] = "Viewing Supasite Data";
    $supa["content"] = view_backup($file);
  } else {
    $supa["title"] = "Oops";
    $supa["content"] = common_status("You do not have the proper privilege to backup Supasite data.");
  }
}

function supa_database_restore() {
  global $login, $file;
  $supa = &$GLOBALS['supa'];
  if($login[priv] <= 2) {
    $supa["title"] = "Restore Supasite Data";
    $supa["content"] = restore_form($file);
  } else {
    $supa["title"] = "Oops";
    $supa["content"] = common_status("You do not have the proper privilege to restore Supasite data.");
  }
}
function supa_database_restoring() {
  global $login, $HTTP_POST_VARS;
  $supa = &$GLOBALS['supa'];
  if($login[priv] <= 2) {
    $supa["title"] = "Restore Supasite Data";
    $supa["content"] = restoring(
      $HTTP_POST_VARS[file],
      $HTTP_POST_VARS[table_news],
      $HTTP_POST_VARS[table_comments],
      $HTTP_POST_VARS[table_news_topics],
      $HTTP_POST_VARS[table_settings],
      $HTTP_POST_VARS[table_usernames]
    );
  } else {
    $supa["title"] = "Oops";
    $supa["content"] = common_status("You do not have the proper privilege to restore Supasite data.");
  }
}

### MOD MANAGER FRONTEND FUNCTIONS ###
function manage_modules($msg = '') {
  global $modules, $supa;

  ### put loaded modules into an array ###
  $loaded_mods = explode("::", $modules[loaded]);

  ### read mod files and check them against loaded modules array ###
  $d = dir("$supa[mod_path]");
  while($entry = $d->read()) {
    if((is_dir("$supa[mod_path]/$entry")) && ($entry != '.') && ($entry != '..')) {
      $r .= "  <tr>\n";
      $r .= "    <td>$entry</td>\n";
      if(in_array($entry, $loaded_mods))
        $r .= "    <td><b>Installed</b></td>\n    <td>[ <a href=\"index.php?act=database_uninstall&amp;mod=$entry\">uninstall</a> ]</td>\n  </tr>\n\n";
      else
        $r .= "    <td>Not Installed</td>\n    <td>[ <a href=\"index.php?act=database_install&amp;mod=$entry\">install</a> ]</td>\n  </tr>\n\n";
    }
  }
  $d->close();

  $header = "  <tr>\n";
  $header .= "    <th style=\"width:200px; text-align:left;\">Module Name</th>\n";
  $header .= "    <th style=\"width:100px; text-align:left;\">Module Status</th>\n";
  $header .= "    <th style=\"width:100px\"></th>\n";
  $header .= "  </tr>\n\n";

  if(!$r)
    $r = "  <tr><td colspan=\"3\">No Supasite modules found.</td></tr>\n";
  if($msg != '')
    $msg = common_status($msg);
  return "$msg<table cellpadding=\"5\">\n$header$r</table>\n\n";
}

function module_install($mod_name) {
  global $supa, $modules;
  $loaded_mods = explode("::", $modules[loaded]);

  if(!in_array($mod_name, $loaded_mods)) {
    include_once("$supa[mod_path]/$mod_name/index.php");
    if(install())
      return manage_modules("Module $mod_name installed succesfully.  <a href=\"index.php?act=database_manage_modules\">Reload</a> to view changes.");
    else
      return manage_modules("Errors encountered while installing $mod_name.");
  } else {
    return manage_modules("Module $mod_name already installed.");
  }
}

function module_uninstall($mod_name, $conf = '') {
  global $supa, $modules;
  $loaded_mods = explode("::", $modules[loaded]);

  if(in_array($mod_name, $loaded_mods)) {
    if($conf == 'yes') {
      ### uninstall confirmed ###
      include_once("$supa[mod_path]/$mod_name/index.php");
      if(uninstall())
        return manage_modules("Module $mod_name uninstalled succesfully.  <a href=\"index.php?act=database_manage_modules\">Reload</a> to view changes.");
      else
        return manage_modules("Errors encountered while uninstalling $mod_name.");
    } else {
      ### uninstall not confirmed ###
      return common_status("Are you sure you want to remove the module <b>$mod_name</b>?  Any database data relating to the module will be lost.<br /><a href=\"index.php?act=database_uninstall&amp;mod=$mod_name&amp;conf=yes\">yes</a>");
    }
  } else {
    return manage_modules("Module $mod_name not installed.");
  }
}

function backup_menu($msg='') {
  global $supa;
  if($msg != '')
    $list = common_status($msg);
    $list .= "<p>current backup --&gt; [ <a href=\"index.php?act=database_viewbackup&amp;file=supasite.sql\">view</a> | <a href=\"$supa[web_path]$supa[supa_path]/files/backup/supasite.sql\">download</a> | <a href=\"index.php?act=database_restore&amp;file=supasite.sql\">restore</a> ]</p>\n";
    $list .= "<p>current news backup (TWML) --&gt; [ <a href=\"index.php?act=database_viewbackup&amp;file=news.bak.twml\">view</a> | <a href=\"index.php?act=database_downloadbackup&amp;file=news.bak.twml\">download</a> ]</p>\n";
    return $list;
}

### BACKUP/RESTORE FRONTEND FUNCTIONS ###
function backup_form($msg='') {
  global $PHP_SELF, $supa;
  if($msg != '')
    $form = common_status($msg);

  $form .= backup_menu();
  $form .= "<form action=\"$PHP_SELF\" method=\"post\">\n";
  $form .= "<p><input type=\"submit\" name=\"submit\" value=\"Backup Data\" />\n";
  $form .= "<input type=\"hidden\" name=\"act\" value=\"database_backing_up\" /></p>\n";
  $form .= "</form\n\n";

  return $form;
}

function backing_up() {
  global $modules, $supa, $meta;

  if(file_exists($supa['backup_path'])) {
    ### save files to /files/backup ###
    include_once($modules[modules_newsFilename]);
    $GLOBALS['posts'] = backend_getNewsData();
    build_twml("$supa[backup_path]/news.bak.twml");
    foreach($supa[table_array] as $table) {
      $data .= export_sql($table);
    }
    $header = "# Supasite SQL Dump - $supa[version]\n";
    $header .= "# timestamp - ".date('Y-m-d H:i')."\n\n$data";
    write_backup("supasite.sql", $header);
    return backup_form("$meta[title] data saved in SQL format.");
    ### files have been backed up, now either offer it as a download or display it ###
  } else {
    ### backup path does not exist ###
    return backup_form("Backup path does not exist.  Please create the path \"$supa[backup_path]\" before trying to backup the data.");
  }
}

function export_sql($table) {
  global $supa;
  $tbl_data = backend_getTableData($table);
  $sql .= "# TABLE - $table\n";
  if(count($tbl_data) > 0) {
    foreach($tbl_data as $row) {
      foreach($row as $k=>$v) {
        if( (!is_numeric($k)) && ($k != '') ) { // if its any field other than an 'id' field...
          $v = addslashes($v);
          $v = str_replace("\\\\\\", "\\", $v);
          $values .= ", '$v'";
        }
      } // end $row foreach
      $values = substr($values, 2);
      $sql .= "INSERT INTO $table VALUES ($values);\n";
      unset($values);
    } // end $tbl_data foreach
  } // end count IF
  return $sql."\n";
}

### takes data and writes file ###
function write_backup($file, $data) {
  global $supa;
  $filename = "$supa[backup_path]/$file";
  $fh = fopen($filename, 'w');
  $check = @fwrite($fh, $data);
  @fclose($fh);
  return $check;
}

function view_backup($file) {
  global $supa;
  $filename = "$supa[backup_path]/$file";
  if(!strpos($file, '/')) {
    $fh = @fopen($filename, "r");
    $data = htmlentities(@fread($fh, filesize($filename)));
    $view = "<pre>\n$data\n</pre>";
    $filesize = common_getFilesize($filename, 'k');
    return backup_menu("Viewing the contents of '$file' ($filesize).") . $view;
  } else {
    ### it's not in the array ###
    return backup_form('Invalid $file input.');
  }
}

### RESTORE FUNCTIONS ###
function show_sql_files() {
  global $supa;
  if(file_exists($supa[backup_path])) {
    $d = dir($supa[backup_path]); // reading the dir
    while($file = $d->read()) { // making an array of all sql files
      if( (substr($file, -4) == '.sql') && ($file != 'supasite.sql') )
        $sql_list .= "<li>$file [ <a href=\"index.php?act=database_viewbackup&amp;file=$file\">view</a> | <a href=\"index.php?act=database_restore&amp;file=$file\">restore</a> ]</li>\n";
    }
    $list = "<p><b>SQL files</b> to restore from<br />";
    $list .= "<ul>\n<li>supasite.sql (main backup) [ <a href=\"index.php?act=database_viewbackup&amp;file=supasite.sql\">view</a> | <a href=\"index.php?act=database_restore\">restore</a> ]</li>\n";
    return $list . $sql_list . "</ul>\n\n";
  } else {
    ### backup path does not exist ###
    return common_status("Backup path does not exist.  Please create the path \"$supa[backup_path]\" and put any .sql files there.");
  }
}
function scan_for_tables($file) {
  global $supa;
  $sql_file = "$supa[backup_path]/$file";
  $fh = @fopen($sql_file, 'r');
  while (!feof($fh)) {
    $line = @fgets($fh, 4096);
    if(substr($line, 0, 9) == '# TABLE -') {
      ereg( "# TABLE - ([_a-z]*)", $line, $vars);
      if(in_array($vars[1], $supa[table_array]))
        $tbl_array[] = $vars[1];
    }
  }
  return $tbl_array;
}

function restore_form($file='', $msg='') {
  global $supa;
  if($msg != '')
    $form = common_status($msg);
  if($file == '')
    $file = 'supasite.sql';
  $sql_file = "$supa[backup_path]/$file";

  ### getting the timestamp from the second line ###
  $fh = @fopen($sql_file, 'r');
  @fgets($fh, 4096);
  $timestamp = substr(@fgets($fh, 4096), 14);

  $form .= show_sql_files();

  $form .= "<form action=\"index.php\" method=\"post\">\n";
  $form .= "<table cellpadding=\"10\">\n<tr>\n  <td>\n";
  $form .= "    <p><b>Tables to Restore</b> ($file)<br />\n";
  $form .= "    <small>Supasite data backed up on ".trim($timestamp).".</small></p>\n    <ul>\n";
  $tbl_array = scan_for_tables($file);
  foreach($tbl_array as $table_name) {
    $form .= "    <li><input type=\"checkbox\" name=\"table_$table_name\" value=\"1\" checked=\"checked\"/> $table_name</li>\n";
  }
  $form .= "    </ul>\n";
  $form .= "  </td><td valign=\"middle\">\n";
  $form .= "    <p><input type=\"submit\" name=\"submit\" value=\"Restore\" />\n";
  $form .= "    <input type=\"hidden\" name=\"file\" value=\"$file\" />\n";
  $form .= "    <input type=\"hidden\" name=\"act\" value=\"database_restoring\" /></p>\n";
  $form .= "  </td>\n</tr>\n</table>\n</form>\n\n";

  $message = "<i>Warning --</i> If you do a restore of the tables, any old data will be lost!";
  $form .= common_status($message);
  return $form;
}

#function scan_for_tables(

function restoring($file, $news=0, $comments=0, $news_topics=0, $settings=0, $usernames=0) {
  global $supa;
  foreach($supa[table_array] as $table) {
    if($$table)
      $tables[] = $table; // making array of all tables being restored
  }
  if(!is_array($tables))
    $tables = array(); // if no tables being restored, then make a blank array
  $filename = "$supa[backup_path]/$file";
  $fh = @fopen($filename, "r"); // open file
  while (!feof($fh)) { // loop through each line
    $line = @fgets($fh, 4096);
    if(substr($line, 0, 9) == '# TABLE -') { // if it's a comment, pull the table name out
      ereg( "# TABLE - ([_a-z]*)", $line, $vars);
      if(in_array($vars[1], $tables)) {
        $current_table = $vars[1];
        backend_clearTable($current_table);
      } else {
        unset($current_table);
      }
    } elseif( ($current_table) && (substr($line, 0, 6) == 'INSERT') ) { // no comment, so it must be an SQL query
      backend_restoreQuery(trim($line));
    }
  }
  @fclose ($fh);
  foreach($tables as $t) {
    $tbl_list .= "$t, ";
  }
  return restore_form($file, 'Restored '.substr($tbl_list, 0, strlen($tbl_list)-2).'.');
}
?>