<?php
/*
Supasite - web based PHP/mySQL/XML content management tool
Copyright (C) 2001 - Rick Olson (rick@techno-weenie.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

SCRIPT NAME:  admin_db_news.php (frontend)
DESC:  manages news using a database
*/

require_once("$supa[db_path]/$supa[db]_news.php"); # loads the backend functions

/* *** FRONT END FUNCTIONS *** */
function supa_news_add() {
  global $HTTP_POST_VARS;
  $supa = &$GLOBALS['supa'];

  if(!$HTTP_POST_VARS['submit']) {
    $supa["title"] = "Add News";
    $supa["content"] = add_news_form(); # show the form
  } else {
    $supa["title"] = "Adding News";
    $supa["content"] = add_news(
      $HTTP_POST_VARS['subject'],
      $HTTP_POST_VARS['post'],
      $HTTP_POST_VARS['topic']
    ); # update the database and show the form
  }
}

function supa_news_list() {
  global $site, $num;
  $supa = &$GLOBALS['supa'];

  $supa["title"] = "Listing $site[newsage] News Entries";
  $supa["content"] = list_news($num, 0);
}

function supa_news_edit() {
  global $id, $HTTP_POST_VARS;
  $supa = &$GLOBALS['supa'];

  if($id) { # $id, $user, $date, $time, $subject, $post, $topic
    if(!$HTTP_POST_VARS['submit']) {
      $supa["title"] = "Edit News";
      $supa["content"] = edit_news_form($id);
    } else {
      $supa["title"] = "Editing News";
      $supa["content"] = edit_news(
        $id,
        $HTTP_POST_VARS['user'],
        $HTTP_POST_VARS['date'],
        $HTTP_POST_VARS['time'],
        $HTTP_POST_VARS['subject'],
        $HTTP_POST_VARS['post'],
        $HTTP_POST_VARS['topic']
      );
    }
  } else {
    $supa["title"] = "Oops...";
    $supa["content"] = list_news(0, '', "News ID is invalid.");
  }
}

function supa_news_delete() {
  global $id;
  $supa = &$GLOBALS['supa'];

  if($id) {
    $supa["title"] = "Delete News Post #$id?";
    $supa["content"] = delete_news($id, $GLOBALS[conf]);
  } else {
    $supa["title"] = "Oops...";
    $supa["content"] = list_news(0, "News ID is invalid.");
  }
}

function supa_comments_list() {
  global $id;
  $supa = &$GLOBALS['supa'];

  if($id) {
    $supa["title"] = "List Comments";
    $supa["content"] = list_comments($id);
  } else {
    $supa["title"] = "Oops...";
    $supa["content"] = list_news(0, "News ID is invalid.");
  }
}

function supa_comments_delete() {
  global $c_id, $id, $conf;
  $supa = &$GLOBALS['supa'];

  if($c_id) {
    $supa["title"] = "Delete Comment #$c_id?";
    $supa["content"] = delete_comment($id, $c_id, $conf);
  } else {
    $supa["title"] = "Oops...";
    $supa["content"] = list_news(0, '', "Comment ID is invalid.");
  }
}

function supa_news_build_cache() {
  $supa = &$GLOBALS['supa'];
  build_news('cache');
  $supa["title"] = "The cached news has been built.";
  $supa["content"] = common_status("The cached news have been built.");
}

### NEWS TOPICS ###
function supa_news_add_topic() {
  global $submit, $modules, $HTTP_POST_VARS;
  $supa = &$GLOBALS['supa'];
  include($modules[modules_topicsFilename]);

  if(!$HTTP_POST_VARS['submit']) {
    $supa["title"] = "Add News Topic";
    $supa["content"] = add_topic_form(); # show the form
  } else {
    $supa["title"] = "Adding News Topic";
    $supa["content"] = add_topic($HTTP_POST_VARS['topic_name'], $HTTP_POST_VARS['icon']); # update the database and show the form
  }
}

function supa_news_list_topics() {
  global $modules;
  $supa = &$GLOBALS['supa'];
  include($modules[modules_topicsFilename]);
  $supa['title'] = 'List Topics';
  $supa['content'] = list_topics();
}

function supa_news_edit_topic() {
  global $id, $HTTP_POST_VARS, $modules, $t;
  $supa = &$GLOBALS['supa'];
  include($modules[modules_topicsFilename]);

  if($t) {
    $t = str_replace("_", " ", $t);
    if(!$HTTP_POST_VARS['submit']) {
      $supa["title"] = "Edit Topic";
      $supa["content"] = edit_topic_form($t);
    } else {
      global $i, $id;
      $supa["title"] = "Editing Topic";
      $supa["content"] = edit_topic($id, $t, $i);
    }
  } else {
    $supa["title"] = "Oops...";
    $supa["content"] = list_topics("Topic name is invalid.");
  }
}

function supa_news_delete_topic() {
  global $t, $modules, $conf;
  $supa = &$GLOBALS['supa'];
  include($modules[modules_topicsFilename]);

  if($t) {
    $t = str_replace("_", " ", $t);
    $supa["title"] = "Delete Topic #$id?";
    $supa["content"] = delete_topic($t, $conf);
  } else {
    $supa["title"] = "Oops...";
    $supa["content"] = list_topics("News Topic ID is invalid.");
  }
}

/* *** BACKEND FUNCTIONS *** */

### form for adding news ###
function add_news_form($msg = "") {
  global $news, $login, $supa;
  if($msg != "") $form = common_status($msg);

  ### getting topic list
  $t_list = data_getTopicList(0);

  ### making form
  $form .= "<form action=\"index.php\" method=\"POST\">\n";

  ### date/time ###
  $form .= "<p><b>Date</b>: ".date('r')."<br />\n";

  ### topics ###
  $form .= "<b>Topic:</b> <select name=\"topic\">\n";
  foreach($t_list as $k=>$v) {
    $form .= "  <option value=\"$v\">$v</option>\n";
  }
  $form .= "</select><br />\n\n";

  ### subject ###
  $form .= "<b>Subject</b>: <input type=\"text\" name=\"subject\" size=\"50\" maxlength=\"50\" /><br />\n";

  ### post ###
  $form .= "<b>News Text</b>:<br />\n";
  $form .= "<input type=\"checkbox\" name=\"linebreak\" value=\"yes\" checked=\"checked\" class=\"checkbox\"> <span class=\"status\">Automatically convert linebreaks to &lt;br /&gt;</span><br />\n";
  $form .= "<textarea name=\"post\" cols=\"70\" rows=\"20\"></textarea><br />\n";
  $form .= "<input type=\"hidden\" name=\"act\" value=\"news_add\">\n";
  $form .= "<input type=\"submit\" name=\"submit\" value=\"Add &gt;\"></p>\n";
  $form .= "</form>\n\n";
  return $form;
}

### adds news, shows form again ###
function add_news($subject, $post, $topic) {
  global $login, $supa;

  if(backend_addNews(
    $login[username],
    $login[password],
    $subject,
    $post,
    $topic
  )) {
    build_news();
    return add_news_form("Your message was posted on ".date('r').".");
  } else {
    return add_news_form("Encountered problems adding the news post...");
  }
}

### lists news to be edited or deleted ###
function list_news($num, $type = 'page', $msg = '') {
  global $site, $login, $supa;

  if(($num == '') || ($num < 1)) {
    if($type == 'page')
      $num = 0;
    else
      $id = 1;
  }
  if($msg != '') { $list = common_status($msg); }

  $count = data_countPosts(15);

  ### making arrows
  $prev_arrow = "&lt;-- previous $site[newsage] entries";
  $next_arrow = "next $site[newsage] entries --&gt;";
  if($num > 0) {
    $prevnum = $num - 1;
    $arrow = "<a href=\"index.php?act=news_list&amp;num=$prevnum\">$prev_arrow</a>";
  } else {
    $arrow = $prev_arrow;
  }

  $arrow .= ' | ';

  if($num < $count[last_page]) {
    $nextnum = $num + 1;
    $arrow .= "<a href=\"index.php?act=news_list&amp;num=$nextnum\">$next_arrow</a>";
  } else {
    $arrow .= $next_arrow;
  }


  ### calculating page numbers and offsets
  $offset = $site[newsage] * $num; # low end of the displayed range
  $offset = $offset.","; # sets the offset according to the low end

  # increment both by one because not everyone counts like a programmer (0, 1, 2, 3...)
  $current = $num + 1;
  $last = $count[last_page] + 1;

  if($posts = data_getNews($num, 'page', $site[newsage])) {
    $list .= common_status("Showing page $current of $last.");
    $list .= common_status($arrow);
    foreach($posts as $row) {
      $list .= display_post($row);
    }
    $list .= common_status($arrow);
    return $list;
  } else {
    return common_status("Error encountered while gathering news posts.");
  }
}

### given a root ID, show the comments ###
function list_comments($root, $c_id = '', $msg = '') {
  if($msg != '') { $list = common_status($msg); }

  ### getting the post data
  list($id, $row) = each( data_getNews($root, 'id') ) ;
  $list .= display_post($row);

  if($comments = data_getComments($root, $c_id)) {
    foreach($comments as $c_row) {
      $list .= display_comment($c_row, $row[u_id]);
    }
  }

  if(!$err)   return $list;
  else        return $err;
}

### shows form to edit a news post ###
function edit_news_form($id, $msg = '') {
  global $login, $supa;

  if(!$id) {
    return common_status("Invalid ID.");
  } else {
    if($msg != '') $form = common_status($msg);

    $res = data_getNews($id, 'id');
    list($null, $row) = each($res);

    # making form
    $form .= "<form action=\"index.php\" method=\"POST\">\n";
    $form .= "<p><b>Date</b>: <input type=\"text\" name=\"date\" value=\"$row[date_str]\" size=\"12\" maxlength=\"10\" /> <small>yyyy-mm-dd</small><br />\n";
    $form .= "<b>Time</b>: <input type=\"text\" name=\"time\" value=\"$row[time_str]\" size=\"7\" maxlength=\"5\" /> <small>hh:mm (24 hour clock)</small><br />\n";

    if($login[priv] <= 2) { # if they are a super user, let them change the username
      ### get list of users
      $u_list = data_getUserList($row[u_id]);

      ### build user select form ###
      $form .= "<b>Posted by</b>: <select name=\"user\">\n";
      foreach($u_list as $v) {
        $form .= "  <option value=\"$v\">$v</option>\n";
      }
      $form .= "</select><br />\n\n";
    } else { # otherwise, just show them the username
      $form .= "<b>Posted by</b>: $row[username]<br />\n";
      $form .= "<input type=\"hidden\" name=\"user\" value=\"$row[username]\" />\n\n";
    }

    ### get list of topics ###
    if(($row[t_id] < 1) || ($row[t_id] == ''))    $row[t_id] = 1;
    $t_list = data_getTopicList($row[t_id]);

    ### build topic select form ###
    $form .= "<b>Topic</b>: <select name=\"topic\">\n";
    foreach($t_list as $v) {
      $form .= "  <option value=\"$v\">$v</option>\n";
    }
    $form .= "</select><br />\n\n";

    $form .= "<b>Subject</b>: <input type=\"text\" name=\"subject\" size=\"55\" value=\"".strip_tags($row[subject])."\" maxlength=\"50\" /><br />\n";

    $form .= "<b>News Text</b>:<br />\n";
    $form .= "<input type=\"checkbox\" name=\"linebreak\" value=\"yes\" checked=\"checked\"> <span class=\"status\">Automatically convert linebreaks to &lt;br /&gt;</span><br />\n";
    $form .= '<textarea name="post" cols="70" rows="20">'.common_editEntry($row[post])."</textarea><br />\n";
    $form .= "<input type=\"hidden\" name=\"id\" value=\"$id\" />\n";
    $form .= "<input type=\"hidden\" name=\"act\" value=\"news_edit\" />\n";
    $form .= "<input type=\"submit\" name=\"submit\" value=\"Edit &gt;\" /></p>\n";
    $form .= "</form>\n\n";
    return $form;
  }
}

### update news,  shows form again ###
# $authcode, $username, $password, $user, $date, $time, $subject, $post, $topic
function edit_news($id, $user, $date, $time, $subject, $post, $topic) {
  global $supa, $login;
  if(backend_editNews(
    $login[username],
    $login[password],
    $id,
    $user,
    $date,
    $time,
    $subject,
    $post,
    $topic
  )) {
    build_news();
    return edit_news_form($id,"News Post $id edited.");
  } else {
    return list_news(0, '', "Encountered problems editing news post $id...");
  }
}


### delete news from the database ###
function delete_news($id, $conf = 'no') {
  global $supa, $login;
  if($conf != "yes") {
    list($null, $row) = each ( data_getNews($id, 'id') );
    $delete .= display_post($row);
    $delete .= common_status("Are you sure you want to delete news post #$id?<br />\n<a href=\"index.php?act=news_delete&amp;id=$id&amp;conf=yes\">yes</a>");

  } else {
    if(backend_deleteNews($login[username], $login[password], $id)) {
      build_news();
      $delete .= list_news(0, 'page', "News post #$id deleted.");
    } else {
      $delete .= list_news(0, 'page', "Errors deleting post #$id.");
    }
  }
  return $delete;
}

### delete a comment from the database ###
function delete_comment($root, $c_id, $conf = 'no') {
  global $login;

  ### getting the user id of the post
  $user = data_getNews($root, 'id');
  list($null, $post) = each($user);
  $u_id = $post[u_id];

  ### delete action not confirmed yet
  if($conf != 'yes') {

    ### checking privileges
    if(($login[priv] <= 2) || ($login[id] == $u_id)) {
      ### display the comment
      $return .= list_comments($root, $c_id);
      $return .= common_status("Are you sure you want to delete comment #$c_id from news post #$root?<br />\n<a href=\"index.php?act=comments_delete&amp;id=$root&amp;c_id=$c_id&amp;conf=yes\">yes</a>");
    } else {
      $return = common_status("You do not have the proper privilege to delete comment $c_id.");
    }
  ### delete action is confirmed
  } else {
    ### checking privileges, using the user id from up above
    if(($login[priv] <= 2) || ($login[id] == $u_id)) {
      if(backend_deleteComment($login[username], $login[password], $root, $c_id))
        $return = list_comments($root, '', "Comment $c_id from post $id deleted.");
      else
        $return = list_comments($root, '', "Error deleting comment $c_id from post $root.");
    } else {
      $return = common_status("You do not have the proper privilege to delete comment $c_id.");
    }
  }
  return $return;
}

### display a news post in the admin script ###
function display_post($row) {
  global $news, $posted, $login, $supa;
  if(!$posted[$row[date_str]]) { # if the date has not already been printed...
    $list .= "<h1 class=\"date\">:: $row[date]</h1>\n\n";
    $posted[$row[date_str]] = true;
  }

  # show the '[ edit | delete | list comments ]' only if they're a super user or they actually posted it
  if(($login[priv] <= 2) || ($login[id] == $row[u_id] )) {
    if($row[comments] > 0)
      $list_link = "<a href=\"index.php?act=comments_list&amp;id=$row[n_id]\">list comments</a>";
    else
      $list_link = "no comments";

    $edit_links = "[ <a href=\"index.php?act=news_edit&amp;id=$row[n_id]\">edit</a> | <a href=\"index.php?act=news_delete&amp;id=$row[n_id]\">delete</a> | $list_link($row[comments]) ]";
  } else {
    $edit_links = '';
  }

  $time = "@ $row[time]";
  $topic = "[ <b>$row[topic]</b> ]";
  $subject = '<b>'.common_outputEntry($row[subject])."</b><br />\n";

  $list .= "<p>&#8226; $topic $subject".common_outputEntry($row[post])."<br>\n";
  $list .= "<span class=\"small\">posted $time by $row[username] $edit_links</span></p>";
  return $list;
}

# required contents of $array: $array[u_id], $array[c_id], $array[comment], $array[c_num], $array[name], $array[date]
function display_comment($array, $u_id = 0) {
  global $login, $supa;

  if(($login[priv] <= 2) || ($login[id] == $u_id))
    $delete = "[ <a href=\"index.php?act=comments_delete&amp;id=$array[n_id]&amp;c_id=$array[c_id]\">delete</a> ]";

  $return = "<p class=\"comment\">&#8226; $array[comment]<br />\n";
  $return .= "<span class=\"small\">[ ($array[c_num]) $array[name] :: posted on $array[date] ] $delete</span></p>\n\n";
  return $return;
}

function build_news($param = '') {
  global $site, $supa;
  ### by accessing the database here, you don't have to access it for each of the functions below ###
  if($GLOBALS['posts'] = data_getNews('0', 'page', $site[newsage])) {
    if(($site[build] == 1) && ($param != 'cache'))
      build_twml("$supa[include_path]/files/newsfeed.twml");

    if($site[cache] == 1)
      cache_news("$supa[server_path]/$site[cache_filename]");

    if($site[ping] == 1)
      ping_weblogs();

    $GLOBALS['posts'] = 0;
  }
}

### performs actions when the news is updated ###
# such as building to xml, caching the front page, and alerting weblogs.com of an update
function build_twml($filename) {
  global $supa, $meta, $site;

  # start making the TWML file
  $twml = "<?xml version=\"1.0\" encoding=\"utf-8\"?> \n\n<twml>\n\n";
  $twml .= "  <header>\n";
  $twml .= "    <title>$meta[title]</title>\n";
  $twml .= "    <link>http://$supa[domain]</link>\n";
  $twml .= "    <description>$meta[desc]</description>\n";
  $twml .= "    <webmaster>$meta[webmaster]</webmaster>\n";
  $twml .= "    <webmasteremail>$meta[webmasterEmail]</webmasteremail>\n";
  $twml .= "    <buildtime>".date('r')."</buildtime>\n";
  $twml .= "    <language>en-us</language>\n  </header>\n\n";

  # getting the latest news #
  global $posts;
  reset($posts);
  foreach($posts as $row) {
    ### formatting database values for XML ------ ###
    foreach($row as $k=>$v) {
      $row[$k] = htmlentities(stripslashes(trim($v)));
    }

    $date_string = $row[date_str];
    if(!$posted[$date_string]) {
      $posted[$date_string] = 1;

      ### checks to see if this is the first iteration of the loop...
      # if it IS the first... then make $once true... otherwise close up the <newsday> element from the previous iteration
      if(!$once) {
        $once = 1;
      } else {
        $twml .= "  </newsday>\n\n";
      }

      $twml .= "  <newsday>\n";
      $twml .= "    <date>$row[date]</date>\n";
    }

    ### adding domain to the local HREF links ###
    $post = str_replace("href=&quot;/", "href=&quot;http://$supa[domain]/", $row[post]);

    $twml .= "\n    <newsitem>\n";
    $twml .= "      <id>$row[n_id]</id>\n";
    $twml .= "      <url>http://$supa[domain]$supa[web_path]/$site[news_script]/view/$row[n_id]</url>\n";
    $twml .= "      <itemtime>$row[time]</itemtime>\n";
    $twml .= "      <authorname>$row[username]</authorname>\n";
    $twml .= "      <authoremail>$row[email]</authoremail>\n";
    $twml .= "      <topic>$row[topic]</topic>\n";
    $twml .= "      <subject>$row[subject]</subject>\n";
    $twml .= "      <post>$post</post>\n";
    $twml .= "    </newsitem>\n";
  }

  $twml .= "  </newsday>\n";
  $twml .= "</twml>";

  $fh = @fopen($filename, 'w');
  @fwrite($fh, $twml);
}

function cache_news($filename) {
  global $supa, $site, $posts;
  $GLOBALS['is_caching'] = 'main news';
  reset($posts);
  include_once("$supa[include_path]/site_news.php");
  include_once("$supa[include_path]/backend_site.php");
  $GLOBALS['templates'] = new templates_xml();
  global $templates;

  $GLOBALS['posted'] = array();
  while(list($null, $res) = each($posts)) {
    $news .= news_printNews($res);
  }

  $cache = $templates->fill_template($news.news_getArcIndexBottom());
  $fh = @fopen($filename, 'w');
  @fwrite($fh, $cache);
  unset($GLOBALS['is_caching']);
}

/* notifies Weblogs.com of an update...
 * originally authored by Matt Bean -- bean@yaysoft.com
 * http://www.yaysoft.com/pingweblogs.php
 *
 * used with permission
 */
function ping_weblogs() {
  global $meta, $supa, $act;
  if($act = 'news_add') { // only ping if you're adding a new post!
    $name = $meta[title];
    $url = "http://$supa[domain]$supa[web_path]";
    $xml = "<?xml version=\"1.0\"?><methodCall><methodName>weblogUpdates.ping</methodName><params><param><value>$name</value></param><param><value>$url</value></param></params></methodCall>";
    $fp = fsockopen("rpc.weblogs.com", 80, &$errnum, &$errstr);

    if(!$fp) {
      echo "$errstr ($errnum)<br>\n";
    } else  {
      $len = strlen($xml);
      fputs($fp,"POST /RPC2 HTTP/1.0\r\n");
      fputs($fp,"User-Agent: $supa[version]\r\n");
      fputs($fp,"Content-Type: text/xml\r\n");
      fputs($fp,"Content-length: $len\r\n\r\n");
      fputs($fp,$xml);
      fclose($fp);
      echo "<!-- ping! -->";
    }
    /* we don't need no stinkin' output! */
  }
}
?>