<?php
/*
Supasite - web based PHP/mySQL/XML content management tool
Copyright (C) 2001 - Rick Olson (rick@techno-weenie.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

SCRIPT NAME:  admin_settings.php (frontend)
DESC:  handles modifying of site settings
*/

# load this to get the different template vars
require_once("$supa[include_path]/backend_site.php");
require_once("$supa[db_path]/$supa[db]_settings.php");

/* *** FRONT END FUNCTIONS *** */
function supa_settings_template() {
  global $HTTP_POST_VARS, $var, $login;
  $supa = &$GLOBALS['supa'];

  if((!$HTTP_POST_VARS['submit']) && (!$var)) {
    $supa["title"] = "Change Templates";
    $supa["content"] = change_template(); # show the form
  } elseif($var) {

    global $load, $delete;
    switch($var) {
      case 'load':
        if($load) {
          $supa["title"] = "Loading Template '$load'";
          $supa["content"] = load_template($login[username], $login[password], $load);
        } elseif($delete) {
          $supa["title"] = "Deleting Template '$delete'";
          $supa["content"] = delete_template($login[username], $login[password], $delete);
        } else {
          $supa["title"] = "Listing Templates";
          $supa["content"] = listing_templates();
        }
      break;

      case 'loading':
      break;

      case 'save':
        $supa["title"] = "Saving Template";
        $supa["content"] = save_template($login[username], $login[password], $HTTP_POST_VARS['saved_name']);
      break;

      case 'info':
        $supa["title"] = "Change Template Info";
        $supa["content"] = changing_templateInfo(
          $login[username], $login[password],
          $HTTP_POST_VARS['title'],
          $HTTP_POST_VARS['author'],
          $HTTP_POST_VARS['email'],
          $HTTP_POST_VARS['website'],
          $HTTP_POST_VARS['desc']
        );
      break;
    }

  } else {
    $supa["title"] = "Changing Templates";
    $supa["content"] = changing_template(
      $login[username],
      $login[password],
      $HTTP_POST_VARS['updated_template'],
      $HTTP_POST_VARS['data']
    ); # update the file and show the form
  }
}

function supa_settings_site() {
  global $HTTP_POST_VARS, $login;
  $supa = &$GLOBALS['supa'];

  if(!$HTTP_POST_VARS['submit']) {
    $supa["title"] = "Change Site Configuration";
    $supa["content"] = change_config(); # show the form
  } else {
    $supa["title"] = "Changing Site Configuration";
    $supa["content"] = changing_config(
      $login[username],
      $login[password],
      $HTTP_POST_VARS['newsage'],
      $HTTP_POST_VARS['date_string'],
      $HTTP_POST_VARS['time_string'],
      $HTTP_POST_VARS['tags'],
      $HTTP_POST_VARS['news_script'],
      $HTTP_POST_VARS['search_script'],
      $HTTP_POST_VARS['build'],
      $HTTP_POST_VARS['cache'],
      $HTTP_POST_VARS['cache_filename'],
      $HTTP_POST_VARS['ping']
    ); # update the file and show the form
  }
}

function supa_settings_meta_tag() {
  global $HTTP_POST_VARS, $login;
  $supa = &$GLOBALS['supa'];

  if(!$HTTP_POST_VARS['submit']) {
    $supa["title"] = "Change Meta Configuration";
    $supa["content"] = change_metaConfig(); # show the form
  } else {
    $supa["title"] = "Changing Meta Configuration";
    $supa["content"] = changing_metaConfig(
      $login[username],
      $login[password],
      $HTTP_POST_VARS['display'],
      $HTTP_POST_VARS['ms'],
      $HTTP_POST_VARS['title'],
      $HTTP_POST_VARS['desc'],
      $HTTP_POST_VARS['keywords'],
      $HTTP_POST_VARS['webmaster'],
      $HTTP_POST_VARS['webmasterEmail'],
      $HTTP_POST_VARS['copyright'],
      $HTTP_POST_VARS['robots'],
      $HTTP_POST_VARS['disable']
    ); # update the file and show the form
  }
}

function supa_settings_server_stats() {
  global $login, $modules;
  $supa = &$GLOBALS['supa'];
  include($modules[modules_utilitiesFilename]);

  if($login[priv] == 1) {
    $supa['title'] = "Viewing Site Statistics";
    $supa['content'] = utilities_serverStats();
  } else {
    $supa['title'] = "Doh!";
    $supa['content'] = common_status("You do not have the proper privilege to use the utilities.");
  }
}

function supa_settings_fix_dates() {
  global $login, $modules;
  $supa = &$GLOBALS['supa'];
  include($modules[modules_utilitiesFilename]);

  if($login[priv] == 1) {
    $supa['title'] = "Deleting all posts with an invalid datetime";
    $supa['content'] = utilities_fixDates($login[username], $login[password]);
  } else {
    $supa['title'] = "Doh!";
    $supa['content'] = common_status("You do not have the proper privilege to use the utilities.");
  }

}

function supa_settings_fix_posts() {
  global $login, $modules, $HTTP_GET_VARS;
  $action = $HTTP_GET_VARS[action];
  $supa = &$GLOBALS['supa'];
  include($modules[modules_utilitiesFilename]);

  if($login[priv] == 1) {
    if($action == 'fix')
      $verb = "Fixing";
    else
      $verb = "Deleting";
    $supa['title'] = $verb." all posts with no ID";
    $supa['content'] = utilities_fixPosts($login[username], $login[password], $action);
  } else {
    $supa['title'] = "Doh!";
    $supa['content'] = common_status("You do not have the proper privilege to use the utilities.");
  }

}

function supa_settings_del_root() {
  global $login, $modules;
  $supa = &$GLOBALS['supa'];
  include($modules[modules_utilitiesFilename]);

  if($login[priv] == 1) {
    $supa['title'] = "Deleting all comments with no root ID";
    $supa['content'] = utilities_delRoot($login[username], $login[password]);
  } else {
    $supa['title'] = "Doh!";
    $supa['content'] = common_status("You do not have the proper privilege to use the utilities.");
  }
}

function supa_settings_count_comments() {
  global $login, $modules;
  $supa = &$GLOBALS['supa'];
  include($modules[modules_utilitiesFilename]);

  if($login[priv] == 1) {
    $supa['title'] = "Fixing all posts with invalid comment counts";
    $supa['content'] = utilities_countComments($login[username], $login[password]);
  } else {
    $supa['title'] = "Doh!";
    $supa['content'] = common_status("You do not have the proper privilege to use the utilities.");
  }
}

function supa_settings_optimize() {
  global $login, $modules, $tbl;
  $supa = &$GLOBALS['supa'];
  include($modules[modules_utilitiesFilename]);

  if($login[priv] == 1) {
    $supa['title'] = "Optimizing all database tables";
    $supa['content'] = utilities_optimize($login[username], $login[password], $tbl);
  } else {
    $supa['title'] = "Doh!";
    $supa['content'] = common_status("You do not have the proper privilege to use the utilities.");
  }
}

function supa_settings_fix_users() {
  global $login, $HTTP_POST_VARS, $modules;
  $supa = &$GLOBALS['supa'];
  include($modules[modules_utilitiesFilename]);

  if($login[priv] == 1) {
    $supa['title'] = "Fixing all posts with an invalid User ID";
    $supa['content'] = utilities_fixUsers($login[username], $login[password], $HTTP_POST_VARS['u_id']);
  } else {
    $supa['title'] = "Doh!";
    $supa['content'] = common_status("You do not have the proper privilege to use the utilities.");
  }
}

function supa_settings_fix_topics() {
  global $login, $HTTP_POST_VARS, $modules;
  $supa = &$GLOBALS['supa'];
  include($modules[modules_utilitiesFilename]);

  if($login[priv] == 1) {
    $supa['title'] = "Fixing all posts with an invalid Topic ID";
    $supa['content'] = utilities_fixTopics($login[username], $login[password], $HTTP_POST_VARS['t_id']);
  } else {
    $supa['title'] = "Doh!";
    $supa['content'] = common_status("You do not have the proper privilege to use the utilities.");
  }
}

### BACKEND FUNCTIONS ###

### make a form for a given template type ###
function make_template_form($type, $data) {
  global $act, $supa;
  $templates = new templates_xml();

  $var_array = $templates->vars[$type];

  $form .= "<div class=\"boxedarea\">\n";
  $form .= "<p><b>$type template</b> - ";

  ### if variables are available, show them
  if($var_array) {
    ### make the variable list
    $form .= "available variables</p>\n<ul>\n";
    foreach($var_array as $k=>$v) {
      $form .= "<li><i>$k</i> <b>- - &gt;</b> $v</li>\n";
    }
    if($type == 'html') {
      global $addon_functions;
      foreach($addon_functions as $func_name=>$desc) {
        if($desc == '')
          $desc = 'addon function';
        $form .= "<li><i>%FUNCTION::$func_name%</i> <b>- - &gt;</b> $desc</li>\n";
      }
    }
    $form .= "</ul>\n\n";
  } else {
    $form .= "no variables available</p>\n\n";
  }

  if($data == '%empty%') # if it contains just the empty tag, show nothing
    $data = '';

  ### make the form
  $form .= "<form action=\"index.php\" method=\"POST\">\n";
  $form .= "<p><textarea name=\"data\" id=\"$type\" cols=\"70\" rows=\"20\">\n".trim($data)."\n</textarea><br />\n\n";
  $form .= "<input type=\"hidden\" name=\"act\" value=\"$act\">\n";
  $form .= "<input type=\"hidden\" name=\"updated_template\" value=\"$type\">\n";
  $form .= "<input type=\"submit\" name=\"submit\" value=\"Edit $type template\"></p>\n";
  $form .= "</form>\n</div>\n\n";
  return $form;
}

### show form for changing the templates
function change_template($msg='') {
  global $supa, $login, $act;
  if($msg != '') { $temp = common_status($msg); }
  $templates = new templates_xml();

  # check for proper authorization
  if($login[priv] <= 2) {
    ### printing save/load buttons ###

    $list = backend_getTemplateNames();
    $count = count($list);

    $temp .= "<div style=\"text-align:center\"><table>\n";

    if($count > 0)
      $temp .= "<tr>\n  <td style=\"width:50%\">\n".load_template_form($list)."</td>\n  <td style=\"width:50%\">\n";
    else
      $temp .= "<tr>\n  <td style=\"width:100%\">\n";

    $temp .= save_template_form()."</td>\n</tr>\n</table></div>\n\n";

    ### printing INFO ###
    $info = $templates->load_info();
    $temp .= "<form action=\"index.php\" method=\"POST\" class=\"boxedarea\">\n";
    $temp .= "<p><b>Template Info</b><br />\n";
    $temp .= "<span class=\"small\">Title :: <input type=\"text\" name=\"title\" value=\"$info[title]\" size=\"100\" /><br />\n";
    $temp .= "Author :: <input type=\"text\" name=\"author\" value=\"$info[author]\" size=\"100\" /><br />\n";
    $temp .= "Email :: <input type=\"text\" name=\"email\" value=\"$info[email]\" size=\"100\" /><br />\n";
    $temp .= "Website :: <input type=\"text\" name=\"website\" value=\"$info[website]\" size=\"100\" /><br />\n";
    $temp .= "Description :: <input type=\"text\" name=\"desc\" value=\"$info[desc]\" size=\"100\" /></span><br />\n";
    $temp .= "<input type=\"hidden\" name=\"act\" value=\"$act\" />\n";
    $temp .= "<input type=\"hidden\" name=\"var\" value=\"info\" />\n";
    $temp .= "<input type=\"submit\" name=\"submit\" value=\"Edit template info\" /></p>\n</form>\n\n";

    ### print template forms
    foreach($templates->template as $k=>$v) {
      if(($k) && ($v))
        $temp .= make_template_form($k, $v);
    }
    return $temp;
  } else {
    return common_status("You do not have permissions change the templates.");
  }
}

### function that updates the template XML file
function changing_template($username, $password, $updated_template, $data) {
  global $supa;

  $login = auth_login($username, $password);

  # checking for valid login
  if($login[priv] <= 2) {

    $templates = new templates_xml();
    if($data == '') # if it's empty, give it an %empty% tag
      $data = '%empty%';

    $data = common_outputEntry($data);

    $templates->write_template($updated_template, $data);
    return change_template("Template '$updated_template' updated successfully.");
  }
  return common_status("You do not have permissions to change the templates.");
}

function changing_templateInfo($username, $password, $title, $author, $email, $website, $desc) {
  if( ($login = auth_login($username, $password)) && ($login[priv] <= 2) ) {
    global $supa;
    $templates = new templates_xml();
    $templates->info['title'] = common_outputEntry($title);
    $templates->info['author'] = common_outputEntry($author);
    $templates->info['email'] = common_outputEntry($email);
    $templates->info['website'] = common_outputEntry($website);
    $templates->info['desc'] = common_outputEntry($desc);
    $templates->write_template();
    return change_template("Template Info updated successfully.");
  } else {
    return common_status("You do not have the proper privileges to edit the template info.");
  }
}

function listing_templates() {
  global $supa, $act;
  $d = dir($supa[template_dir]);
  while($f=$d->read()) {
      if(($f != '.') && ($f != '..') && ($f != 'templates.xml') && ($f != 'templates.bak') && (substr($f, -4) == '.xml')) {
        # parse XML files and get the title and description here #
        $temp = new settings_xml("$supa[template_dir]/$f");
        $info = $temp->info;
        $load .= "<p><b>$info[title]</b> ($f) by <a href=\"mailto:$info[email]\">$info[author]</a> (<a href=\"$info[website]\">url</a>)<br />\n";
        $load .= "$info[desc]<br />\n";
        $load .= "[ <a href=\"index.php?act=$act&submit=yes&var=load&load=$f\">load</a> ] - [ <a href=\"index.php?act=$act&submit=yes&var=load&delete=$f\">delete</a> ]</p>\n\n";
        $t_count++;
      }
  }
  $d->close();

  if($t_count > 0)
    return "<h1>:: Load Saved Template</h1>\n\n$load";
  else
    return change_template("No saved templates are available.");
}

function delete_template($username, $password, $delete) {
  global $supa;
  $login = auth_login($username, $password);

  # checking for valid login
  if($login[priv] <= 2) {

    if(backend_deleteTemplate($delete))
      return change_template("Template '$delete' deleted.");
    else
      return change_template("Template not deleted.");
  } else {
    return common_status("You do not have permissions to change the templates.");
  }
}

function load_template($username, $password, $load) {
  global $supa;
  $login = auth_login($username, $password);

  # checking for valid login
  if($login[priv] <= 2) {
    if(backend_loadTemplate($load))
      return change_template("Template '$load' loaded.");
    else
      return common_status("Bad filename '$load'.");
  } else {
    return common_status("You do not have permissions to change the templates.");
  }
}

function save_template($username, $password, $saved_name) {
  global $supa;
  $login = auth_login($username, $password);

  # checking for valid login
  if($login[priv] <= 2) {
    if(backend_saveTemplate($saved_name))
      return change_template("Template saved to '$saved_name.'");
    else
      return change_template("Template save failed.");
  } else {
    return common_status("You do not have permissions to change the templates.");
  }
}

### CONFIG ###

### show the forms for editing the settings
function change_config($msg='') {
  global $supa, $login, $act, $site, $news;
  ### check for proper authorization
  if($login[priv] == 1) {

    if($msg != '')
      $form .= common_status($msg);

    ### build the form
    $form .= "<form action=\"index.php\" method=\"POST\">\n";

    $form .= "<p class=\"settings\"><b>_Site Config</b></p>\n\n";
    $form .= "<p>&#8226; Number of posts to display on the front page.<br />\n";
    $form .= "<b>News Age:</b>  <input type=\"text\" name=\"newsage\" value=\"$site[newsage]\"></p>\n\n";
    $form .= "<p>&#8226; String used to convert the date to a readable format (<i>read about <a href=\"mysql_date_format.htm\">DATE_FORMAT()</a></i>).<br />\n";
    $form .= "<b>Date String:</b>  <input type=\"text\" name=\"date_string\" value=\"$site[date_string]\"></p>\n\n";
    $form .= "<p>&#8226; String used to convert the time to a readable format (<i>read about <a href=\"mysql_date_format.htm\">DATE_FORMAT()</a></i>).<br />\n";
    $form .= "<b>Time String:</b>  <input type=\"text\" name=\"time_string\" value=\"$site[time_string]\"></p>\n\n";
    $form .= "<p>&#8226; List of allowable HTML tags that can be entered in the Comments.<br />\n";
    $form .= "<b>Allowable Tags:</b>  <input type=\"text\" name=\"tags\" value=\"$site[tags]\" style=\"width:300px;\"></p>\n\n";
    $form .= "<p>&#8226; Filename of the script that displays the news for the site.<br />\n";
    $form .= "<b>News Script Filename:</b> <input type=\"text\" name=\"news_script\" value=\"$site[news_script]\"></p>\n\n";
    $form .= "<p>&#8226; Filename of the search engine.<br />\n";
    $form .= "<b>Search Script Filename:</b> <input type=\"text\" name=\"search_script\" value=\"$site[search_script]\"></p>\n\n";
    $form .= "<p>&#8226; Build news to XML?<br />\n";
    if($site[build] == 1)
      $check = " checked=\"checked\"";
    $form .= "<b>Build:</b> <input type=\"checkbox\" name=\"build\" value=\"1\"$check /></p>\n\n";
    unset($check);

    $form .= "<p>&#8226; Cache front page?<br />\n";
    if($site[cache] == 1)
      $check = " checked=\"checked\"";
    $form .= "<b>Cache:</b> <input type=\"checkbox\" name=\"cache\" value=\"1\"$check /></p>\n\n";
    $form .= "<p>&#8226; Filename of the cached front page.<br />\n";
    $form .= "<b>Cache Filename:</b> <input type=\"text\" name=\"cache_filename\" value=\"$site[cache_filename]\"></p>\n\n";
    unset($check);

    if($site[ping] == 1)
      $check = " checked=\"checked\"";
    $form .= "<p>&#8226; Ping Weblogs.com?<br />\n";
    $form .= "<b>Ping:</b> <input type=\"checkbox\" name=\"ping\" value=\"1\"$check /></p>\n\n";

    $form .= "<p><input type=\"hidden\" name=\"act\" value=\"$act\">\n";
    $form .= "<input type=\"submit\" name=\"submit\" value=\"Edit Settings\"></p></form>";
    return $form;
  } else {
    return common_status("You do not have permissions to change the templates.");
  }
}

### make the changes to the database
function changing_config($username, $password, $newsage, $date_string, $time_string, $tags, $news_script, $search_script, $build, $cache, $cache_filename, $ping) {
  $login = auth_login($username, $password);

  if($login['priv'] == 1) {
    if(backend_changeConfig($newsage, $date_string, $time_string, $tags, $news_script, $search_script, $build, $cache, $cache_filename, $ping))
      return change_config("Change operation successful.  <a href=\"index.php?act=settings_site\">Reload</a> to view changes.");
    else
      return change_config("Errors updating configuration.");
  } else {
    return common_status("You do not have permissions to change the settings.");
  }
}

### META ###

### show the forms for editing the settings
function change_metaConfig($msg='') {
  global $supa, $login, $act, $meta, $news;
  ### check for proper authorization
  if($login[priv] == 1) {

    if($msg != '')
      $form .= common_status($msg);

    ### build the form
    $form .= "<form action=\"index.php\" method=\"POST\">\n";

    $form .= "<p class=\"settings\"><b>_Meta Config</b></p>\n\n";

    $form .= "<p>&#8226; Title of the website<br />\n";
    $form .= "<b>Title:</b> <input type=\"text\" name=\"title\" value=\"$meta[title]\" style=\"width:250px;\"></p>\n\n";
    $form .= "<p>&#8226; The site's description<br />\n";
    $form .= "<b>Description:</b> <input type=\"text\" name=\"desc\" value=\"$meta[desc]\" style=\"width:400px;\"></p>\n\n";
    $form .= "<p>&#8226; Keywords used to describe the site<br />\n";
    $form .= "<b>Keywords:</b> <input type=\"text\" name=\"keywords\" value=\"$meta[keywords]\" style=\"width:400px;\"></p>\n\n";
    $form .= "<p>&#8226; Head webmaster of the site<br />\n";
    $form .= "<b>Webmaster:</b> <input type=\"text\" name=\"webmaster\" value=\"$meta[webmaster]\"></p>\n\n";
    $form .= "<p>&#8226; Email address for the webmaster<br />\n";
    $form .= "<b>Webmaster Email:</b> <input type=\"text\" name=\"webmasterEmail\" value=\"$meta[webmasterEmail]\" style=\"width:200px;\"></p>\n\n";
    $form .= "<p>&#8226; Copyright string<br />\n";
    $form .= "<b>Copyright:</b> <input type=\"text\" name=\"copyright\" value=\"$meta[copyright]\" style=\"width:200px;\"></p>\n\n";
    $form .= "<p>&#8226; Instructions to web search engines on what to index and follow.<br />\n";
    $form .= "<b>Robots:</b> <input type=\"text\" name=\"robots\" value=\"$meta[robots]\" style=\"width:200px;\"></p>\n\n";

    $form .= "<p>&#8226; Display Meta Tags or not?<br />\n";
    if($meta[display] == 1)
      $check = " checked=\"checked\"";
    $form .= "<b>Display:</b> <input type=\"checkbox\" name=\"display\" value=\"1\"$check /></p>\n\n";
    unset($check);

    $form .= "<p>&#8226; Display MS Meta Tags (to disable smart tags and the image toolbar in IE6) or not?<br />\n";
    if($meta[ms] == 1)
      $check = " checked=\"checked\"";
    $form .= "<b>Display MS Meta Tags:</b> <input type=\"checkbox\" name=\"ms\" value=\"1\"$check /></p>\n\n";

    $form .= "<p>&#8226; Disable any Meta Tag fields?  Seperate values with a semicolon (;).  Example:  title;desc;keywords<br />\n";
    $form .= "Possible Values:<br />\n";
    $form .= "<ul style=\"margin:0 30px;\">\n  <li>generator - shows what version of Supasite created it.</li>\n";
    $form .= "  <li>desc - shows your description of the website.</li>\n";
    $form .= "  <li>keywords - shows the keywords to the website.</li>\n";
    $form .= "  <li>author - shows the main author of the website (retrieved from the Webmaster field).</li>\n";
    $form .= "  <li>copyright - the copyright string applied to the site.</li>\n";
    $form .= "  <li>robots - instructions to web search engines on what to index and follow.</li>\n</ul>\n";
    $form .= "<b>Disable</b>: <input type=\"text\" name=\"disable\" value=\"$meta[disable]\" style=\"width:300px;\" /></p>\n\n";


    $form .= "<p class=\"small\"><a href=\"http://www.htmlhelp.com/reference/html40/head/meta.html\">meta tag help<a></p>\n\n";
    $form .= "<p><input type=\"hidden\" name=\"act\" value=\"$act\">\n";
    $form .= "<input type=\"submit\" name=\"submit\" value=\"Edit Meta Tag Settings\"></p></form>";
    return $form;
  } else {
    return common_status("You do not have permissions to change the templates.");
  }
}

### make the changes to the database
function changing_metaConfig($username, $password, $display, $ms, $title, $desc, $keywords, $webmaster, $webmasterEmail, $copyright, $robots, $disable) {
  $login = auth_login($username, $password);

  if($login['priv'] == 1) {
    if(backend_changeMetaConfig($display, $ms, $title, $desc, $keywords, $webmaster, $webmasterEmail, $copyright, $robots, $disable))
      return change_metaConfig("Change operation successful.  <a href=\"index.php?act=settings_meta_tag\">Reload</a> to view changes.");
    else
      return change_metaConfig("Errors while trying to update.");
  } else {
    return common_status("You do not have permissions to change the settings.");
  }
}

# sets $var = save
function save_template_form() {
  global $act;
  $temp .= "<form action=\"index.php\" method=\"POST\">\n";
  $temp .= "<p><input type=\"hidden\" name=\"act\" value=\"$act\">\n";
  $temp .= "<input type=\"hidden\" name=\"var\" value=\"save\">\n";
  $temp .= "Filename: <input type=\"text\" name=\"saved_name\" style=\"text-align:right;\">.xml\n";
  $temp .= "<input class=\"small\" type=\"submit\" name=\"submit\" value=\"Save &gt;\"></p>\n</form>\n\n";
  return $temp;
}

# sets $var = 'load' if there are any templates
function load_template_form($list) {
  global $act;
  $temp .= "<form action=\"index.php\" method=\"POST\">\n";
  $temp .= "<p><b>Load:</b> ";
  foreach($list as $f) {
    $temp .= "[ <a href=\"index.php?act=settings_template&submit=yes&var=load&load=$f\">$f</a> ] \n";
  }
  $temp .= "<br />\n<input type=\"hidden\" name=\"act\" value=\"$act\">\n";
  $temp .= "<input type=\"hidden\" name=\"var\" value=\"load\">\n";
  $temp .= "<input class=\"small\" type=\"submit\" name=\"submit\" value=\"List Saved Templates\"></p>\n</form>\n\n";
  return $temp;
}
?>