<?php
/*
Supasite - web based PHP/mySQL/XML content management tool
Copyright (C) 2001 - Rick Olson (rick@techno-weenie.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

SCRIPT NAME:  admin_topics.php (frontend)
DESC:  builds forms for the admin interface of working with topics
*/

require_once("$supa[db_path]/$supa[db]_topics.php");

/* *** BACKEND FUNCTIONS *** */

### shows the form for adding topics
function add_topic_form($msg = '') {
  global $login;
  if($login[priv] <= 2) {
    if($msg != "") $form = common_status($msg);

    # making form
    $form .= "<form action=\"index.php\" method=\"POST\">\n";
    $form .= "<p><b>Topic Name</b>:  <input type=\"text\" name=\"topic_name\" size=\"20\" maxlength=\"20\" /><br />\n";
    $form .= "<b>Topic Icon</b>: <input type=\"text\" name=\"icon\" size=\"30\" maxlength=\"30\" /><br />\n";
    $form .= "<input type=\"hidden\" name=\"act\" value=\"news_add_topic\">\n";
    $form .= "<input type=\"submit\" name=\"submit\" value=\"Add &gt;\"></p>\n";
    $form .= "</form>\n\n";
    return $form;
  } else {
    return common_status('You do not have the proper privilege to add a topic');
  }
}

### adds topic, shows form again ###
function add_topic($topic_name, $icon) {
  global $login;

  if($login[priv] > 2)
    $err = "You do not have the proper privilege to add a topic";

  if($topic_name == '')
    $err = "Topic is empty.";

  if(!$err) {
    if(backend_addTopic($login[username], $login[password], $topic_name, $icon))
      return add_topic_form("Topic <b>$topic_name</b> added successfully.");
    else
      return common_status('Unable to add topic.');
  } else {
    return add_topic_form($err);
  }
}

### lists topics ###
function list_topics($msg = '') {
  global $login, $supa;

  if($msg != '') { $results = common_status($msg); }

  $t_list = data_getTopicList();
  foreach($t_list as $v) {
    $results .= "<b>$v</b>";
    if($login[priv] == 1) {
      $t = str_replace(" ", "_", $v);
      $results .= " [ <a href=\"$supa[web_path]$supa[supa_path]/index.php?act=news_edit_topic&amp;t=$t\">edit</a> | <a href=\"$supa[web_path]$supa[supa_path]/index.php?act=news_delete_topic&amp;t=$t\">delete</a> ]<br />\n";
    } else {
      $results .= "<br />\n";
    }
  }

  return "<p>$results</p>\n\n";
}

function edit_topic_form($t, $msg = '') {
  global $login;

  if($login[priv] <= 2) {
    if($msg != "") $form = common_status($msg);

    $t = str_replace("_", " ", $t);
    $t_infoArr = data_getTopicInfo( data_getTopicID($t) );
    $t_info = $t_infoArr[0];

    # making form
    $form .= "<form action=\"index.php\" method=\"POST\">\n";
    $form .= "<p><b>Topic Name</b>:  <input type=\"text\" name=\"t\" size=\"30\" maxlength=\"20\" value=\"$t_info[topic]\" /><br />\n";
    $form .= "<b>Topic Icon</b>: <input type=\"text\" name=\"i\" size=\"40\" maxlength=\"30\" value=\"$t_info[icon]\" /><br />\n";
    $form .= "<input type=\"hidden\" name=\"act\" value=\"news_edit_topic\" />\n";
    $form .= "<input type=\"hidden\" name=\"id\" value=\"$t_info[id]\" />\n";
    $form .= "<input type=\"submit\" name=\"submit\" value=\"Edit &gt;\"></p>\n";
    $form .= "</form>\n\n";
    return $form.list_topics();
  } else {
    return common_status('You do not have the proper privilege to edit a topic');
  }
}

### edits topic, shows form again ###
function edit_topic($id, $topic_name, $icon) {
  global $login;
  if(backend_editTopic($login[username], $login[password], $id, $topic_name, $icon))
    return list_topics("Topic <b>$topic_name</b> edited successfully.");
  else
    return common_status('Errors editing topic.');
}

### delete topic from the database ###
function delete_topic($topic_name, $conf = 'no') {
  global $login;

  if($login[priv] <= 2) {
    if($conf != 'yes') {
      $t = str_replace(" ", "_", $topic_name);
      return common_status("Are you sure you want to delete topic <b>$topic_name</b>?<br />\n<a href=\"index.php?act=news_delete_topic&amp;t=$t&amp;conf=yes\">yes</a>");
    } else {
      if(backend_deleteTopic($login[username], $login[password], $topic_name))
        return list_topics("News Topic <b>$topic_name</b> deleted.");
      else
        return list_topics("Errors deleting Topic <b>$topic_name</b>.");
    }
  } else {
    return common_status("You do not have the proper privilege to delete a toipc.");
  }
}
?>