<?php
/*
Supasite - web based PHP/mySQL/XML content management tool
Copyright (C) 2001 - Rick Olson (rick@techno-weenie.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

SCRIPT NAME:  mysql_site.php (backend)
DESC:  loads templates to display the site
*/

### getting the templates file pulling out the values
require_once("$supa[include_path]/site_addons.php");

### declaring the templates_xml class ###

class templates_xml extends xml {
  ### set the arrays with the variable info ###
  var $vars = array(
    'html' => array("%title%"=>"Title of the current page.", '%meta_tags%'=>'Meta Tags for the site.', '%css%'=>'The stylesheets for the site.', '%news_arrows%'=>'The prev/next arrows', "%content%"=>"The main filling of the site generated by PHP.", "%gt%"=>"Greater than sign (&gt;)", "%lt%"=>"Less than sign (&lt;)", '%dot%'=>"Dot (&#8226;)", '%copy%'=>"Copyright (&copy;)"),
    'css' => 0,
    'date' => array("%date%"=>"Current Date.", "%datelink%"=>"Current Date (also links to a search query for that day)", "%gt%"=>"Greater than sign (&gt;)", "%lt%"=>"Less than sign (&lt;)", '%dot%'=>"Dot (&#8226;)", '%copy%'=>"Copyright (&copy;)"),
    'news' => array("%n_id%"=>"ID of the current post.", "%subject%"=>"Subject of the post.", '%topic_name%'=>'This post\'s topic.', '%topic_icon%'=>'Returns the associated icon for this topic.', "%post%"=>"The actual post.", "%view_url%"=>"Static URL for the post.", "%username%"=>"Name of the user who posted this.", "%email%"=>"Poster's email address.", "%comments%"=>"Number of comments to this post.", "%gt%"=>"Greater than sign (&gt;)", "%lt%"=>"Less than sign (&lt;)", '%dot%'=>"Dot (&#8226;)", '%copy%'=>"Copyright (&copy;)"),
    'comments' => array('%c_id%'=>'ID of the comment.', '%c_num%'=>'Comment number for the post.', '%n_id%'=>'ID of the news post this comment belongs to.', '%name%'=>'Name of the person who posted this.', '%date%'=>'Date the comment was posted.', '%comment%'=>'Actual body of the comment.', "%gt%"=>"Greater than sign (&gt;)", "%lt%"=>"Less than sign (&lt;)", '%dot%'=>"Dot (&#8226;)", '%copy%'=>"Copyright (&copy;)"),
    'archiveList' => array('%current_month%'=>'Link to all the posts made this month.', '%current_year%'=>'The current year in 4 digit format.', '%current_year_months%'=>'Links to posts made on every month of the current year.', '%last_year%'=>'Shows last year in 4 digit format.', '%last_year_months%'=>'Links to posts made on every month of the previous year.', "%gt%"=>"Greater than sign (&gt;)", "%lt%"=>"Less than sign (&lt;)", '%dot%'=>"Dot (&#8226;)", '%copy%'=>"Copyright (&copy;)"),
    'arrow' => array("%count_string%"=>"Shows number of pages or the last news id, depending on the news mode", "%gt%"=>"Greater than sign (&gt;)", "%lt%"=>"Less than sign (&lt;)", '%dot%'=>"Dot (&#8226;)", '%copy%'=>"Copyright (&copy;)"),
    'prev' => array("%units%"=>"Shows either the previous page or previous id, depending on the news mode", "%gt%"=>"Greater than sign (&gt;)", "%lt%"=>"Less than sign (&lt;)", '%dot%'=>"Dot (&#8226;)", '%copy%'=>"Copyright (&copy;)"),
    'next' => array("%units%"=>"Shows either the next page or next id, depending on the news mode", "%gt%"=>"Greater than sign (&gt;)", "%lt%"=>"Less than sign (&lt;)", '%dot%'=>"Dot (&#8226;)", '%copy%'=>"Copyright (&copy;)"),
  );

  var $current;
  var $template = array();
  var $info =  array();

  ### constructor ###
  function templates_xml() {
    global $supa;
    $file = "$supa[template_dir]/templates.xml";
    $this->xml($file);
    $this->parse_xml();
    $this->load_templates();
  }

  ### start_element ###
  function start_element($parser, $name, $attribs) {
    if($name == 'template')
      $this->current = $attribs[name];

    array_push($this->stack, $name);
  }

  ### stop_element ###
  function stop_element($parser, $name) {
    array_pop($this->stack);
  }

  ### cdata ###
  function char_data($parser, $data) {
    $parent = $this->get_parent();
    switch($parent) {
      case 'template':
        $this->template[$this->current] .= $data;
      break;

      case 'info':
      case 'twml':
      break;

      default:
        $this->info[$parent] .= $data;

      break;
    }
  }

  ### save template to a different filename
  function save_template($s) {
    global $supa;
    if((strpos($s, '/')) || (strpos($s, '.')) || ($s == '')) { # check for valid filename
      return 0; exit;
    }

    $saved_name = $s.'.xml';
    ### save template ###
    if(!copy("$supa[template_dir]/templates.xml", "$supa[template_dir]/$saved_name"))
      return 0;
    else
      return 1;
  }

  ### write template to file
  function write_template($template_name = '', $new_data = '') {
    global $supa;
    if($template_name != '')
      $this->template[$template_name] = $new_data;

    ### ok back to your template BS ###
    $new_template = "<?xml version=\"1.0\"?>\n\n<twml>\n\n";

      ### write out INFO changes ###
      $info = $this->load_info();
      $new_template .= "\t<info>\n\t\t<title>$info[title]</title>\n\t\t<author>$info[author]</author>\n";
      $new_template .= "\t\t<email>$info[email]</email>\n\t\t<website>$info[website]</website>\n";
      $new_template .= "\t\t<desc>$info[desc]</desc>\n\t</info>\n\n";

      ### write out TEMPLATE changes ###
      foreach($this->template as $k=>$v) {
        if(($k) && ($v)) {
          $new_template .= "\t<template name=\"$k\">\n\t\t<![CDATA[".trim($v)."]]>\n\t</template>\n\n";
        }
      }

      $new_template .= "</twml>";

      ### make a backup ###
      if(!copy("$supa[template_dir]/templates.xml", "$supa[template_dir]/templates.bak"))
        return common_status("Template backup failed.");

      ### save changes to the file ###
      $file = fopen("$supa[template_dir]/templates.xml", "w");
      if(fputs($file, $new_template))
        return change_template("The $template_name template has been updated!");
      else
        return common_status("File write operation failed.");
  }

  ### getting the templates file pulling out the values
  function load_templates() {
    foreach($this->template as $k=>$v) {
      if(trim($v) == '%empty%') # if it has the %empty% tag, clear it
        $v = '';
      $this->template[$k] = $v;
    }
  }

  function return_templates() {
    return $this->template;
  }

  function load_info() {
    return $this->info;
  }

  ### fills the HTML template with the content
  function fill_template($content) {
    global $site, $meta, $supa;
    $template = $this->template;
    ### replacing functions ###
    while(ereg("%FUNCTION::([_a-zA-Z]*)%", $template[html], $vars)) {
      $func = "addon_$vars[1]";
      $template[html] = str_replace("%FUNCTION::$vars[1]%", $func(), $template[html]);
    }
    $html = $template[html];
    $search = array("%title%", "%content%", '%css%', '%meta_tags%', '%news_arrows%');
    $replace = array($meta[title], $content, $template['css'], meta_tags(), news_printArrows());
    $search = site_pushVars($search, 'search');
    $replace = site_pushVars($replace);

    for($i = 0; $i < count($search); $i++) {
      $html = str_replace($search[$i], $replace[$i], $html);
    }

    return trim($html);
  }
}

### returns the generated meta tags ###
function meta_tags() {
  global $meta, $supa;

  /* only display if the user wants meta tags */
  if($meta[display] == 1) {
    /* generate the meta tags */
    $m['generator'] = "<meta name=\"GENERATOR\" content=\"$supa[version]\" />\n";
    $m['desc'] = "<meta name=\"DESCRIPTION\" content=\"$meta[desc]\" />\n";
    $m['keywords'] = "<meta name=\"KEYWORDS\" content=\"$meta[keywords]\" />\n";
    $m['author'] = "<meta name=\"AUTHOR\" content=\"$meta[webmaster] - Email: $meta[webmasterEmail]\" />\n";
    $m['copyright'] = "<meta name=\"COPYRIGHT\" content=\"$meta[copyright]\" />\n";
    $m['robots'] = "<meta name=\"ROBOTS\" content=\"$meta[robots]\" />\n";
    if($meta[ms] == 1) /* only set this if the user wants it */
      $m['$ms'] = "<meta name=\"MSSmartTagsPreventParsing\" content=\"TRUE\">\n<meta http-equiv=\"imagetoolbar\" content=\"no\">\n";

    $dis = explode(";", $meta[disable]);
    foreach($m as $m_name=>$m_value) {
      if(!in_array($m_name, $dis))
        $metatag .= $m_value;
    }
  return $metatag;
  }
}

### pushes the common template variables
function site_pushVars($array, $mode = 'replace') {
  if($mode == 'search')
    array_push($array, '%gt%', '%lt%', '%dot%', '%copy%');
  else
    array_push($array, '&gt;', '&lt;', '&#8226;', '&copy;');

  return $array;
}
?>