<?php
/*
Supasite - web based PHP/mySQL/XML content management tool
Copyright (C) 2001 - Rick Olson (rick@techno-weenie.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

SCRIPT NAME:  config.php
DESC:  Grabs configuration from the database
*/

### SUPASITE VARIABLES ###

/* EDIT THESE
 * server_path -  server path to the web root dir\
 * web_path - root dir of the site
 * supa_path - path to the admin script
 * domain - domain of the web site (for cookie settings)
 * authcode - auth code to verify this client with the central server
 * xmlrpc_authcode - simple password to authenticate with the xmlrpc gateway
 */
$supa["server_path"] = "EDIT THIS";
$supa["web_path"] = ''; # if the site's address is on the root (ie: http://techno-weenie.com) then leave it blank
$supa["supa_path"] = "/supasite";
$supa["domain"] = "localhost"; # leave out the http:// in this
$supa['xmlrpc_authcode'] = 'EDIT THIS';

/* DATA ACCESS INFO -- EDIT THESE TOO
 * The rest are required ONLY if you're using a database
 *
 * host - IP address for database
 * user - username for logging in to the database
 * pass - database password
 * dbname - name of the database that all the tables are in
 */
 $supa['db'] = 'mysql';
$supa['host'] = "localhost";
$supa['user'] = "";
$supa['pass'] = "";
$supa['dbname'] = "supa";

/* STARTING COMPRESSION
 *  If your PHP version is less than 4.04, comment this next line out
 *  for a description of this next line, go to http://www.php.net/manual/en/function.ob-gzhandler.php */
ob_start(ob_gzhandler); ### dynamically caches output if browser supports it

/* DO NOT EDIT BELOW THIS LINE */
$supa["path_info"] =        $HTTP_SERVER_VARS['PATH_INFO'];
$supa["include_path"] =   $supa[server_path].$supa[supa_path];
$supa['template_dir'] =   "$supa[include_path]/files";
$supa['db_path'] = "$supa[include_path]/db";
$supa['mod_path'] = "$supa[include_path]/mods";
require_once("$supa[include_path]/common_functions.php");

$config = data_getConfig();
foreach($config as $type=>$p_array) {
  foreach($p_array as $p=>$v) {
    ${$type}[$p] = $v;
  }
}
unset($p, $v, $type);
?>