<?php
/*
Supasite - web based PHP/mySQL/XML content management tool
Copyright (C) 2001 - Rick Olson (rick@techno-weenie.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

SCRIPT NAME:  mysql_api.php
DESC:  declares common mySQL database class
*/

class database {

  ### constructor function ###
  # take these values from the $supa array #
  function database($host, $user, $pass, $dbname) {
    $this->dbname = $dbname;
    if(!mysql_connect($host, $user, $pass))
      echo "Database connection failed.";
  }

  ### common query news list fields ###
  function list_fields($date, $time) {
  return "SELECT n.id as n_id, DATE_FORMAT(datetime, '%Y-%m-%d') AS date_str, DATE_FORMAT(datetime, '%H:%i') AS time_str, DATE_FORMAT(datetime, '$date') AS date, DATE_FORMAT(datetime, '$time') AS time, post, comments, subject, topic_id as t_id, username, u.id as u_id, email, n_t.topic_name as topic, views, icon
                            FROM news AS n, usernames AS u, news_topics as n_t WHERE n.user_id = u.id AND n.topic_id = n_t.id";
  }

  ### other functions ###

  ### runs a query and spits out an error message if it didn't go through.  this WILL NOT return any results
  function run_query($query) {
    $this->query($this->dbname, $query);
    if($error = mysql_error()) {
      echo "<p><b>SQL Error</b>: $error</p>\n\n<p>SQL Query: $query</p>\n\n";
      return 0;
    } else {
      return 1;
    }
  }

  ### runs a query, checks for errors, puts all the results in an array, frees the results, and returns the array ###
  function get_results($query) {
    $res = $this->query($this->dbname, $query);
    if($error = mysql_error()) {
      echo "<p><b>SQL Error</b>: $error</p>\n\n<p>SQL Query: $query</p>\n\n";
    } elseif($this->num_rows($res) > 0) {
      while($row = $this->fetch_array($res)) {
        $arr[] = $row;
      }
      $this->free_result($res);
      return $arr;
    }
  }

  ### gets the next row of a result array ###
  function next_result(&$res_array) {
    $arr = @each($res_array);
    return $arr[1];
  }

  function last_id() {
    return mysql_insert_id();
  }

  function free_result($results=0) {
    if((is_resource($results)) && (get_resource_type($results) == 'mysql link'))
      mysql_free_result($results);
  }

  # replacement for a simple mysql function
  function num_fields($results) {
    return mysql_num_fields($results);
  }

  # replacement for a simple mysql function
  function num_rows($results) {
    return mysql_num_rows($results);
  }

  # replacement for a simple mysql function
  function fetch_row($results) {
    return mysql_fetch_row($results);
  }

  # replacement for a simple mysql function
  function fetch_array($results) {
    return mysql_fetch_array($results);
  }

  # replacement for a simple mysql function
  function result($results, $offset) {
    return mysql_result($results, $offset);
  }

  # replacement for a simple mysql function
  function query($dbname, $query) {
    return mysql_db_query($dbname, $query);
  }

  # replacement for a simple mysql function
  function list_tables($dbname) {
    return mysql_list_tables($dbname);
  }

  # replacement for a simple mysql function
  function tablename($results, $i) {
    return mysql_tablename($results, $i);
  }
}

### database connectivity stuff ###
$db = new database($supa[host], $supa[user], $supa[pass], $supa[dbname]);

### COMMON DATABASE FUNCTIONS ###

### returns the sql query for pulling news from the database
# $type sets how $num is used...
#     'page' - used as a page number
#     'id'       - used as a post id
function data_listQuery($num, $type = 'page', $limit = 1) {
    global $site, $db;
    switch($type) {
      case 'page':
        $offset = $num * $limit . ", ";
      break;

      case 'id':
        $idMSG = " AND n.id = $num ";
      break;
    }

    return trim($db->list_fields($site[date_string], $site[time_string]).$idMSG."
              ORDER BY datetime DESC, n.id DESC LIMIT $offset$limit;");
}

### COMMON DATA FUNCTIONS ###

function data_getYears() {
  global $db;
  $res = $db->get_results("SELECT YEAR(datetime) AS year FROM news GROUP BY year;");
  $years = array();
  while($row = $db->next_result(&$res)) {
    $years[] = $row[year];
  }
  return $years;
}

### get the first posted date
function data_firstDate() {
  global $db, $site;
  ### getting the first posted date ###
  $result = $db->get_results("SELECT DATE_FORMAT(datetime, '$site[date_string]') AS date FROM news ORDER BY id LIMIT 1");
  $res = $db->next_result(&$result);
  return $res[date];
}

### NEWS ###

function backend_submitNewsQuery($query) {
  global $db, $site, $HTTP_GET_VARS;

  if($HTTP_GET_VARS['debug_sql'] == 1) {
    $query = str_replace("\r\n", " ", $query);
    $query = str_replace("  ", " ", $query);
    echo "<!-- Debugging SQL Query --\n $query -->\n\n";
  }

  $res = $db->get_results($query);
  if(count($res) < 1)
    return 0;
  else
    return $res;
}

# counts the number of posts and pages of news
### BUILD ERROR CODES ###
function data_countPosts($limit = 1) {
  global $db, $site;
  $count_posts = $db->get_results("SELECT id FROM news ORDER BY id DESC;");
  $row = $db->next_result(&$count_posts);
  $numposts = count($count_posts);
  $numpages = $numposts / $limit;

  $count["pages"] = ceil($numpages); # total number of pages
  $count["posts"] = $numposts; # total number of posts
  $count["last_page"] = $count[pages] - 1;
  $count["last_id"] = $row[id]; # last posted ID
  return $count;
}

### lists news from the database ###
# gets news by page number or by ID...  returns array of values
function data_getNews($num, $type, $limit = 1) {
  global $db;
  return backend_submitNewsQuery(data_listQuery($num, $type, $limit));
}

### gets comments from database
# by root [and ID if it's given]... returns array of values
function data_getComments($root, $c_id = '', $limit = '') {
  global $db;
  if($c_id != '')
    $comment_id = " AND id = '$c_id'";
  if($limit != '')
    $limit_str = "LIMIT $limit";
  $c_query = "SELECT id AS c_id, root AS n_id, DATE_FORMAT(date, '%b-%e-%Y') AS date, date AS date_str, name, www, comment FROM comments WHERE root = '$root'$comment_id ORDER BY date_str $limit_str;";
  $res = $db->get_results($c_query);
  if(count($res) < 1)
    $err = 1;

  if(!$err)   return $res;
  else        return 0;
}

### COMMENTS ###

### counts comments for a specified news post
function data_countComments($id = '') {
  global $db;
  if($id != '')
    $where = "WHERE root = '$id'";
  $res = $db->get_results("SELECT count(id) AS count FROM comments $where;");
  $num = $db->next_result(&$res);
  return $num[count];
}

### TOPICS ###

### if an id is given, return ONLY that one
function data_getTopicInfo($id = '') {
  global $db;
  if($id != '')
    $where_sql = "WHERE id = '$id'";

  $res = $db->get_results("SELECT topic_name as topic, id, icon FROM news_topics $where_sql ORDER BY topic_name;");
  if(count($res) < 1)
    $err = 1;

  if(!$err)   return $res;
  else        return 0;
}

### given a topic id, returns the topic
function data_getTopic($topic_id) {
  global $db;
  $res = $db->get_results("SELECT topic_name AS topic FROM news_topics WHERE id = '$topic_id';");
  if($row = $db->next_result(&$res))
    return $row[topic];
  else
    return 0;
}

### given a topic, returns the topic id
function data_getTopicID($topic) {
  global $db;
  ### get user_id and topic_id ###
  $res = $db->get_results("SELECT id FROM news_topics WHERE topic_name = '$topic';");
  if($row = $db->next_result(&$res))
    return $row[id];
  else
    return 0;
}

### queries DB for news topics
### if t_id is given, show it FIRST then show the rest afterwards
function data_getTopicList($t_id = '') {
  global $db;
  $list = array();

  # if a value is given, show it first
  if($t_id != '') {
    $where = "WHERE id != '$t_id'";

    ### get the current topic
    $res = $db->get_results("SELECT id, topic_name as t FROM news_topics WHERE id = '$t_id';");
    $row = $db->next_result(&$res);
    $list[$row[id]] = $row[t];
  }

  ### get the rest of the topics
  $res = $db->get_results("SELECT id, topic_name as t FROM news_topics $where ORDER BY id;");
  while($row = $db->next_result(&$res)) {
    $list[$row[id]] = $row[t];
  }
  return $list;
}


### USERS ###

### if a user_id is given, only return THAT user
function data_getUserInfo($user_id = '') {
  global $db;
  if($user_id != '')
    $where = " WHERE id = '$user_id'";

  return $db->get_results("SELECT id, username, password, priv, email, www, num_posts, last_timestamp FROM usernames$where;");
}

### queries DB for user list... given a user id, show it FIRST, then return the others
function data_getUserList($user_id = '') {
  global $db;

  # if a value is given...
  if($user_id != '') {
    $where = "WHERE id != '$user_id'"; # set the where statement

    ### get the current user
    $first_result = $db->get_results("SELECT username FROM usernames WHERE id = '$user_id';");
    $row = $db->next_result(&$first_result);
    $user_array[] = $row[username];
  }

  ### get the rest of the users
  $results = $db->get_results("SELECT id, username FROM usernames $where ORDER BY id;");
  while($row = $db->next_result(&$results)) {
    $user_array[] = $row[username];
  }
  return $user_array;
}

### given a user id, returns the username
function data_getUser($user_id) {
  global $db;
  ### get user_id and topic_id ###
  $res = $db->get_results("SELECT username FROM usernames WHERE id = '$user_id';");
  if($row = $db->next_result(&$res))
    return $row[0];
  else
    return 0;
}

### given a username, returns the user id
function data_getUserID($user) {
  global $db;
  ### get user_id and topic_id ###
  $res = $db->get_results("SELECT id FROM usernames WHERE username = '$user';");
  if($row = $db->next_result(&$res))
    return $row[id];
  else
    return 0;
}

### MISC ###

function data_getConfig() {
  global $db;
  $res = $db->get_results("SELECT param AS p, value AS v, type AS t FROM settings ORDER BY id;");
  while($row = $db->next_result(&$res)) {
    $p = $row[p]; $v = $row[v]; $t = $row[t];
    if($t == 'config')    $t = 'site'; # i use the var $site
    $array[$t][$p] = $v;
  }
  return $array;
}
?>