<?php
/*
Supasite - web based PHP/mySQL/XML content management tool
Copyright (C) 2001 - Rick Olson (rick@techno-weenie.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

SCRIPT NAME:  mysql_news.php (backend)
DESC:  manages news using a database
*/

### BACKEND FUNCTIONS ###

### adds news to the database
# returns 1 or 0 depending on outcome
function backend_addNews($user, $password, $subject, $post, $topic) {
  global $db;

  if(auth_login($user, $password)) {
    ### get user_id and topic_id ###
    $user_id = data_getUserID($user);
    $topic_id = data_getTopicID($topic);

    # converting newlines into <br>
    $post = data_formatEntry($post);
    $subject = strip_tags($subject);

    # inserting into db
    if(($user_id) && ($topic_id) && ($db->run_query("INSERT INTO news (user_id, datetime, subject, post, topic_id) VALUES ('$user_id', NOW(), '$subject', '$post', '$topic_id');")))
      return 1;
    else
      return 0;
  } else {
    return 0;
  }
}

function backend_editNews($username, $password, $id, $user, $date, $time, $subject, $post, $topic) {
  global $db;

  $login = auth_login($username, $password);
  if(is_array($login)) {

    ### must be an EDITOR at least to modify other people's posts ###
    if($login[priv] > 2) {
      $array = data_getNews($id, 'id', 1);
      $row = $array[5];
      if($row['username'] != $username)
        $err = "User has no access to modify this post.";
    }
    ### get user_id and topic_id ###
    $user_id = data_getUserID($user);
    $topic_id = data_getTopicID($topic);

    # converting newlines into <br>
    $post = data_formatEntry($post);
    $subject = strip_tags($subject);

    # inserting into db
    $timestamp = $date.$time.'00';
    if(($user_id) && ($topic_id) && (!$err) && ($db->run_query("UPDATE news SET datetime = '$timestamp', subject = '$subject', topic_id = '$topic_id', post = '$post', user_id = '$user_id' WHERE id = $id;")))
      return 1;
    elseif($err)
      return $err;
    else
      return 0;
  } else {
    return 0;
  }
}

function backend_deleteNews($username, $password, $id) {
  global $db;

  $login = auth_login($username, $password);
  if(is_array($login)) {
    ### must be an EDITOR at least to delete other people's posts ###
    if($login[priv] > 2) {
      $array = data_getNews($id, 'id', 1);
      $row = $array[5];
      if($row['username'] != $username)
        $err = "User has no access to delete this post.";
    }

    if($db->run_query("DELETE FROM news WHERE id = $id;")) {
      return 1;
    } else {
      return 0;
    }
  } else {
    return 0;
  }
}

function backend_deleteComment($username, $password, $root, $c_id) {
  $login = auth_login($username, $password);
  if(is_array($login)) {
    global $db;
    # delete the comment
    $db->run_query("DELETE FROM comments WHERE id = '$c_id' and root = '$root';");
    # lower the comment count
    $res = $db->get_results("SELECT comments FROM news WHERE id = '$root';");
    $row = $db->next_result(&$res);
    $db->run_query("UPDATE news SET comments = '".--$row[comments]."' WHERE id = '$root';");
    return 1;
  } else {
    return 0;
  }
}

### if viewing a news id, add one to the view count ###
function backend_addViewCount($id) {
  global $db;
  if($res = $db->get_results("SELECT views AS v FROM news WHERE id = '$id';")) {
    $row = $db->next_result(&$res);
    $db->run_query("UPDATE news SET views = '".++$row[v]."' WHERE id = '$id';");
  }
  $db->free_result($res);
}

function backend_addComment($root, $name, $www, $comment) {
  global $db;
  if($db->run_query("INSERT INTO comments (root, date, name, www, comment) VALUES ('$root', NOW(), '$name', '$www', '$comment');")) {
    $res = $db->get_results("SELECT comments FROM news WHERE id = '$root';");
    $row = $db->next_result(&$res);
    $db->run_query("UPDATE news SET comments = '".++$row[comments]."' WHERE id = '$root';");
    return 1;
  } else {
    return 0;
  }
  $db->free_result($res);
}

function backend_getNewsByTopic($topic) {
  global $db, $site;
  $topic = str_replace("_", " ", $topic);
  $topic_id = data_getTopicID($topic);
  $topic_query = $db->list_fields($site[date_string], $site[time_string])." AND n.topic_id = '$topic_id' ORDER BY datetime DESC, n.id DESC LIMIT $site[newsage];";
  return backend_submitNewsQuery($topic_query);
}

function backend_getNewsArchives($month, $year, $day) {
  global $db, $site;
  if($day > 0)
    $like_str = "$year-$month-$day%";
  else
    $like_str = "$year-$month%";
  $arc_query = $db->list_fields($site[date_string], $site[time_string])." AND datetime LIKE '$like_str' ORDER BY datetime DESC, n.id DESC;";
  return backend_submitNewsQuery($arc_query);
}

function backend_returnMonthInfo($limit = 0) {
  global $db;
  if($limit > 0)
    $sql_limit = "LIMIT $limit";
  return $db->get_results("SELECT DISTINCT YEAR(datetime) AS year, DATE_FORMAT(datetime, '%m') AS month, DATE_FORMAT(datetime, '%b') AS monthname FROM news ORDER BY datetime DESC, id DESC $sql_limit;");
}

function backend_submitSearchQ($query, $results = 0) {
  global $db, $site;
  if($results < 1)
    $results = $site[newsage];
  $res = $db->get_results($query);
  $x = 0;
  while(($row = $db->next_result(&$res)) && ($x < $results)) {
    $arr[] = $row;
    $x++;
  }
  $arr['results'] = count($res);
  $arr['query'] = $query;
  return $arr;
}

function backend_simpleSearch($words) {
  global $db, $site;
  $query = backend_breakUpWords($words);
  $q = $db->list_fields($site[date_string], $site[time_string])." $query ORDER BY datetime DESC, n.id DESC;"; # no limit...
  return backend_submitSearchQ($q);
}

function backend_breakUpWords($q, $type = 'any') {
  $words = explode(" ", $q);
  for($i = 0; $i < count($words); $i++) {
    if($type == 'all')
      $query .= "AND post LIKE '%$words[$i]%' ";
    else
      $query .= "OR post LIKE '%$words[$i]%' ";
  }

  if($type != 'all')
    $query = "AND (".substr($query, 3).")";
  return $query;
}

###
# $q = query words
# $w = any, all, exact phrase
# $t = search by topic
# $u = search by username
# $year, $month, $day = search by date
# $sort - sort ascending or descending
# $r = number of results per page
# $current_page = page of results requested
###
function backend_advSearch($words, $w = 'any', $t = 0, $u = 0, $d = '____-__-__', $sort = 'DESC', $r = 0, $current_page = 1) {
  global $db, $site;

  /* before querying, build the SQL query */
  if($w != 'exact')
    $query .= backend_breakUpWords($words, $w);
  else
    $query .= "AND post LIKE '%$words%' ";

  /* searching by topic */
  if($t > 0)
    $query .= " AND topic_id = '$t'";

  /* searching by user */
  if($u > 0)
    $query .= " AND u.id = '$u'";

  /* searching by date */
  if($d != '____-__-__')
    $query .= " AND datetime LIKE '$d%'";

  /* changing the number of results per page */
  if($r == 0)
    $r = $site[newsage];

  /* checking if they're not on page 1 of the results */
  if($current_page > 1) {
    $first = $r * ($current_page - 1);
    $limit = " LIMIT $first, $r";
  } else {
    $current_page = 1; # if no page is set, set it to the first page
  }

  if($sort == '')           $sort = 'DESC';
  if($sort == 'asc')    $sort = '';

  /* NOW query the DB */
  $q = $db->list_fields($site[date_string], $site[time_string])." $query ORDER BY datetime $sort, n.id DESC$limit;"; # no limit...
  return backend_submitSearchQ($q, $r);
}

function backend_dateSearch($d, $sort = 'DESC', $r = 0, $current_page = 1) {
  global $db, $site;
  ### before querying, build the SQL query ###

  ### searching by date ###
  if($d != '________')
    $query .= " AND datetime LIKE '$d%'";

  ### changing the number of results per page ###
  if($r < 1)
    $r = $site[newsage];

  ### checking if they're not on page 1 of the results ###
  if($current_page > 1) {
    $first = $r * ($current_page - 1);
    $limit = " LIMIT $first, $r";
  } else {
    $current_page = 1; # if no page is set, set it to the first page
  }

  if($sort == '')           $sort = 'DESC';
  if($sort == 'asc')    $sort = '';

  ### NOW query the DB ###
  $q = $db->list_fields($site[date_string], $site[time_string])." $query ORDER BY datetime $sort, n.id DESC$limit;"; # no limit...
  return backend_submitSearchQ($q, $r);
}
?>