<?php
/*
Supasite - web based PHP/mySQL/XML content management tool
Copyright (C) 2001 - Rick Olson (rick@techno-weenie.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

SCRIPT NAME:  mysql_settings.php (backend)
DESC:  defines functions and objects for modifying site settings
*/

### -------- SETTINGS --------- ###
class settings_xml extends xml {
  var $info = array();

  ### constructor ###
  function settings_xml($file) {
    $this->xml($file);
    $this->parse_xml();
  }

  ### start_element ###
  function start_element($parser, $name, $attribs) {
    array_push($this->stack, $name);
  }

  ### stop_element ###
  function stop_element($parser, $name) {
    array_pop($this->stack);
  }

  ### cdata ###
  function char_data($parser, $data) {
    $parent = $this->get_parent();
    if(($parent != 'template') && ($parent != 'info') && ($parent != 'twml')) {
      $this->info[$parent] .= $data;
    }
  }
}

function backend_deleteTemplate($delete) {
  global $supa;
  if(unlink("$supa[template_dir]/$delete"))
    return 1;
  else
    return 0;
}

function backend_loadTemplate($load) {
  global $supa;
  if( (!strpos($load, '..')) && (!strpos($load, '/')) && (substr($load, -4) == '.xml') ) {
    unlink("$supa[template_dir]/templates.xml") or die("Could not delete file 'templates.xml'");
    copy("$supa[template_dir]/$load", "$supa[template_dir]/templates.xml") or die ("Could not copy file '$load' to 'templates.xml'");
    return 1;
  } else {
    return 0;
  }
}

function backend_saveTemplate($saved_name) {
  global $supa;
  $templates = new templates_xml();
  if($templates->save_template($saved_name))
    return 1;
  else
    return 0;
}

function backend_changeConfig($newsage, $date_string, $time_string, $tags, $news_script, $search_script, $build, $cache, $cache_filename, $ping) {
  global $db;
  $update_array = array('newsage', 'date_string', 'time_string', 'tags', 'news_script', 'search_script', 'build', 'cache', 'cache_filename', 'ping');
  foreach($update_array as $v) {
    $db->run_query("UPDATE settings SET value = '${$v}' WHERE param = '$v';");
  }
  return 1;
}

function backend_changeMetaConfig($display, $ms, $title, $desc, $keywords, $webmaster, $webmasterEmail, $copyright, $robots, $disable) {
  global $db;
  $update_array = array('display', 'ms', 'title', 'desc', 'keywords', 'webmaster', 'webmasterEmail', 'copyright', 'robots', 'disable');
  foreach($update_array as $v) {
    $db->run_query("UPDATE settings SET value = '${$v}' WHERE param = '$v';");
  }
  return 1;
}

function backend_getTemplateNames() {
  global $supa;
   $d = dir($supa[template_dir]);
   while($f=$d->read()) {
      if(($f != '.') && ($f != '..') && ($f != 'templates.xml') && ($f != 'templates.bak') && (substr($f, -4) == '.xml')) {
        $list[] = $f;
      }
   }
   $d->close();
   return $list;
}

?>