<?php
/*
Supasite - web based PHP/mySQL/XML content management tool
Copyright (C) 2001 - Rick Olson (rick@techno-weenie.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

see the manual for contact information
*/

/* index.php
 * the admin script
 */

# loading required files... #
require_once("config.php");
require_once("$supa[include_path]/admin_auth_cookies.php");

### values set for get_content(); ###
# getting values for content, title, and content_title

if((!is_array($login)) && ($act != 'no_priv') && ($act != 'bad_login')) {
  load_api('login');
} else {
  if(!$act)  {
    $supa["title"] = "Welcome to $supa[version]";
    $supa["content"] = common_status("Choose a menu option from the left to begin your site administration.");
  } else {
    load_api($act);
  }
}
### nothing has been sent to the browser above this coment line ###

##### STARTING HTML #####
#
### TOP ###
echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Strict//EN\" \"http://www.w3.org/TR/html4/strict.dtd\">\n\n";
echo "<html>\n<head>\n";
echo "  <title>$meta[title] - $supa[version]</title>\n";
echo "  <script language=\"Javascript\" src=\"$supa[web_path]$supa[supa_path]/md5.js\"></script>\n";
echo "  <script language=\"Javascript\">\n";
echo "    function validate_login() {\n";
echo "      document.auth_login.passwd.value = calcMD5(document.auth_login.passwd.value);\n";
echo "    }\n";
echo "  </script>\n";
echo "  <style type=\"text/css\">\n";

### changing this will update the font in all the spots at the same time
$font = "Verdana, Arial, Sans-Serif";

echo "BODY {
  background-color:#8C93A2;
  color:#000000;
  margin:0; padding:0;
}

A, A:visited { color:#0000ff; text-decoration:none; }
A:hover, A:active { color:#0000ff; text-decoration:underline; }

TEXTAREA {
  border:solid 1px #000000;
  margin:0; padding:0;
  width:500px; height:300px;
  font:10px/125% <?php echo $font; ?>;
}

INPUT, SELECT {
  margin:0; padding:0;
  border:solid 1px #000000;
}

IMG, FORM {
  border:0;
  margin:0; padding:0;
}

/* FONTS */
H1, .big { font: bold 14px/150% $font; } /* biggest font size */
H2, P, DIV, .med { font: 12px/150% $font; }
H3, .small { font: 10px/150% $font; } /* small text */

.bold { font-weight:bold; }
.center { text-align:center; }
.comment { border-top:dotted 1px #000000; }

/* SECTIONS OF THE PAGE */
.content {  margin:15px 15px 15px 205px;  }

.header {
  background-color:#cccccc;
  width:100%; height:18px;
  border-bottom:solid 2px #000000;
  margin:0 0 15px 0; padding:0;
  font:12px/125% $font;
}

.headerRight {
  position:absolute;
  top:2px;
  right:15px;
  font:10px/125% $font;
  width:500px;
  text-align:right;
}

.headerLeft {
  position:absolute;
  left:15px;
}
.contentTitle {
  background-color:#cccccc;
  border-width:2px 2px 1px 2px;
  border-style:solid;
  border-color:#000000;
  margin:0 15px 0 205px; padding:2px;
  font-weight:bold;
  text-align:center;
}

.contentArea {
  background-color:#ffffff;
  border-width:0 2px 2px 2px;
  border-style:solid;
  border-color:#000000;
  margin:0 15px 15px 205px; padding:5px;
}

.menu {
  background-color:#cccccc;
  border:solid 2px #000000;
  margin:0; padding:5px;
  width:161px; /* sets the correct width for standards compliant browsers */
  /* supasite will not be a slave to bad browsers, including IE5.5! */
  font:10px/125% $font;
  position:absolute;
  top:35px; left:15px;
}

.settings {
  font: bold 14px/150% $font;
  border:solid 1px #000000;
  padding:2px; margin:0;
  width:25%;
  background-color: #eeeeee;
}

/* values for the template textareas */
.boxedarea { margin:5px; border:solid 1px #000000; padding:5px; }

#html { }

#date { height:30px; width:300px; }

#news, #comments { height:75px; }

#arrow { height:30px; width:250px; }

#prev { height:30px; width:200px; }

#next { height:30px; width:200px; }

#archiveList { height:30px }

  </style>\n</head>\n\n<body>\n\n";
?>
<?### HEADER ###
echo "<div class=\"header\"> <!-- START HEADER BAR -->\n";
if($login) {
  echo "<span class=\"headerRight\">\n";
  echo "user <a href=\"mailto:$login[email]\">$login[username]</a> logged in. &gt; <a href=\"index.php?act=users_profile\">change profile</a></span>\n";
}
echo "<b class=\"headerLeft\"><a href=\"$supa[web_path]$supa[supa_path]\">$supa[version]</a></b>\n";
echo "\n</div> <!-- END HEADER -->\n\n";

### CONTENT ###
echo "<!-- START CONTENT -->\n";
echo "<div class=\"contentTitle\">$meta[title] - $supa[title]</div>\n<div class=\"contentArea\">\n\n";
echo $supa[content];
echo "</div> <!-- end contentArea -->\n<!-- END CONTENT -->\n\n";

### MENU ###
echo "<div class=\"menu\"> <!-- START MENU -->\n";
build_menu();
echo "</div> <!-- END MENU -->\n\n";

### BOTTOM ###
echo "</body>\n</html>";

### FUNCTIONS ###

function load_api($act) {
  global $modules, $supa;
  /* load the module library */
  $mods = explode("::", $modules[modules]);
  foreach($mods as $mod_str) {
    list($mod_name, $priv) = explode(":", $mod_str);
    $mod_name = strtolower($mod_name);
    if(substr($act, 0, strlen($mod_name)) == $mod_name) {
      $filename = "modules_".$mod_name."Filename";
      include_once("$supa[include_path]/$modules[$filename]");
    }
  }
  /* adding 'supa_' to the beginning of every action function */
  $supa_function = 'supa_' . $act;
  $supa_function();
}

### build_menu echos the left hand menu
# rewrite
function build_menu() {
  global $modules, $login, $meta, $supa;
  if(is_array($login)) {
    ## building menu options for each section from
    $mods = explode("::", $modules[modules]);
    foreach($mods as $mod_str) {
      #echo $mod_str;
      list($menu_name, $priv) = explode(":", $mod_str);
      $printed_menu_name = str_replace("_", " ", $menu_name);
      if($priv >= $login[priv]) { # checks if they have the proper permissions
        echo "<b>$printed_menu_name</b><br />";
        $menu_name = strtolower($menu_name);
        $actions = explode("::", $modules["modules_$menu_name"]);
        foreach($actions as $act_str) {
          list($item, $priv) = explode(":", $act_str);
          $item_name = str_replace("_", " ", $item);
          if($priv >= $login[priv]) {
            $action = $menu_name."_".$item;
            echo "&gt; <a href=\"$supa[web_path]$supa[supa_path]/index.php?act=$action\">$item_name</a><br />\n";
          }
        }
        echo "<br />\n";
      }

    }
    echo "\n&gt; <a href=\"$supa[web_path]$supa[supa_path]/index.php?act=logout\">logout</a><br /><br />\n";
    echo "&gt; return to <a href=\"$supa[web_path]/\">$meta[title]</a>\n\n";
  } else {
    echo "&gt; <a href=\"$supa[web_path]$supa[supa_path]/index.php?act=login\">login</a>\n\n";
  }
}
?>