<?php
/*
Supasite - web based PHP/mySQL/XML content management tool
Copyright (C) 2001 - Rick Olson (rick@techno-weenie.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

SCRIPT NAME:  site_addons.php (frontend)
DESC:  addon functions for the template
*/

/*
 * These functions can be called in the Supasite templates by entering this:
 * '%FUNCTION::function_name%'
 * Feel free to extend on Supasite's abilities by adding functions in here.
 */

### array that describes the available addon functions ###
### FORMAT:
#  FUNCTION NAME => DESCRIPTION
$GLOBALS['addon_functions'] = array(
  'basicSearchForm' => 'Prints a simple search query form.',
  'calender' => 'Displays the current month\'s calender with the days linked to that day\'s posts',
  'updatedWeblogs' => 'Displays recently updated weblogs via weblogs.com'
);

function addon_basicSearchForm() {
  $blog = 'blog_'.BLOG;
  global $supa;
  $site = &$GLOBALS[$blog];

  $form .= "<form action=\"$supa[web_path]/$site[search_script]\" method=\"get\">\n";
  $form .= "<input type=\"text\" name=\"q\" value=\"search\" onFocus=\"if(this.value=='search')this.value='';\" onBlur=\"if(this.value=='')this.value='search';\" /><br />\n";
  $form .= "[ <a href=\"$supa[web_path]/$site[search_script]\">advanced</a> ]\n";
  return $form."</form>";
}

function addon_calender() {
  global $db, $supa, $site, $arc_year, $arc_month, $arc_day;
  ### $arc_year and $arc_month are set in news.php when viewing archives
  if( (!$arc_year) || (!$arc_month) ) { ### if not set, use the current year/month
    $num = date('m');
    $year = date('Y');
  } else {
    $num = $arc_month;
    $year = $arc_year;
  }

  $current_month = "$year-$num";
  ### getting first/last months
  $res_array = array_reverse(backend_returnMonthInfo());
  list($null, $row) = each($res_array);
  $months['first'] = "$row[year]-$row[month]";
  $months['last'] = date("Y-m");
  # make the arrows
  if($current_month > $months[first]) { # decides whether there's a previous arrow
    $prev_month = $num - 1;
    $prev_year = $year;
    if($prev_month < 1) {
      $prev_year = $year - 1;
      $prev_month = '12';
    }
    if(strlen($prev_month) == 1)
      $prev_month = '0'.$prev_month;

    $prev_arrow = "<a href=\"$supa[web_path]/$site[news_script]/archives/$prev_year-$prev_month\">&lt;</a>";
  } else {
    $prev_arrow = "&lt;";
  }

  if($current_month < $months[last]) { # decides whether there's a next arrow
    $next_month = $arc_month + 1;
    $next_year = $arc_year;
    if($next_month > 12) {
      $next_year = $arc_year + 1;
      $next_month = '01';
    }
    if(strlen($next_month) == 1)
      $next_month = '0'.$next_month;

    $next_arrow = "<a href=\"$supa[web_path]/$site[news_script]/archives/$next_year-$next_month\">&gt;</a>";
  } else {
    $next_arrow = "&gt;";
  }

  ### array of these values -
  # name of the month,
  # day of the week of the first day of the month,
  # and number of days in the month
  $timestamp = mktime(0,0,0,$num,1,$year);
  $month = array( 'name' => date('M.Y', $timestamp), 'firstday' => date('w', $timestamp), 'numdays' => date('t', $timestamp) );

  ### URL to the search page ###
  $url = "$supa[web_path]/$site[news_script]/archives/$year-$num-";

  ### array of the days of the week
  $days = array( 'Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat' );

  ### getting all the days with posts for the current month ###
  $res = $db->get_results("SELECT DISTINCT DATE_FORMAT(datetime, '%e') AS day FROM news WHERE MONTH(datetime) = '$num' AND YEAR(datetime) = '$year';");
  $dates = array();
  while($row = $db->next_result(&$res)) {
    ### putting them into the $dates array
    $dates[] = $row[day];
  }

  ### building the header of the table
  $cal_header = "<tr>\n  <th colspan=\"7\" class=\"caltext calheader\">$prev_arrow $month[name] $next_arrow</th>\n</tr>\n\n";
  $cal_header .= "<tr>\n";
  ### building the 7 columns for each day of the week
  foreach($days as $day) {
    $cal_header .= "  <td class=\"caltext calday\">$day</td>\n";
  }
  $cal_header .= "</tr>";

  $cal_footer = "<tr>\n  <td colspan=\"7\" class=\"caltext calrow\"><a href=\"$supa[web_path]/$site[news_script]/archives\">view archives</a></td>\n</tr>\n\n";

  ### this while loop goes through each day of the month to build the table rows
  # $date is the current day the loop iteration is on
  # while the current date is <= to the number of days in the month...
  while($date <= $month[numdays]) {
    $cal_row .= "<tr>\n";
    ### running a FOR loop for the 7 columns for each day of the week
    for($i = 0; $i < 7; $i++) {
      ### if date is not set and the first day is this weekday,
      # then start the count at 1
      if((!$date) && ($month[firstday] == $i))
        $date = 1;

      ### if the date is set and is <= the number of days in the month...
      if( ($date <= $month[numdays]) && ($date) ) {
  ### check if it's in the $dates array of posted dates
        $check = in_array($date, $dates);

        ### if it IS in the array, put the URL around it
        if( ($date) && ($check) ) {
          ### putting a 0 in front of the date if it's 1 digit for the URL
          if(strlen($date) == 1)
            $href = $url.'0'.$date;
          else
            $href = $url.$date;
          $printed_date = "<a href=\"$href\">$date</a>";

        ### it iS NOT in the array, so no URL
        } elseif( ($date) && (!$check) ) {
          $printed_date = "$date";
        }

        if($date == $arc_day)
          $bgclass = ' calbg';
        else
          unset($bgclass);

      ### either $date is unset or it is > the number of days in the month
      } else {
        unset($printed_date, $bgclass);
      }

      $cal_row .= "  <td class=\"caltext calrow$bgclass\">$printed_date</td>\n";
      ### if the date is valid, increment one day on it
      if(($date > 0) && ($date <= $month[numdays]))
        $date++;
    } # end FOR
    $cal_row .= "</tr>\n\n";
  } # end WHILE

  return "<table class=\"cal\">\n$cal_header$cal_row$cal_footer</table>";
}

function addon_updatedWeblogs() {
  if(!$GLOBALS['is_caching']) { // if it IS caching, then don't bother displaying this
    $count = 5; // set how many updated sites from weblogs.com to display
    $fh = @fopen("http://www.weblogs.com/changes.xml", 'r');
    if($fh) { // only return data if the xml file can be opened
      @fgets($fh, 4096);@fgets($fh, 4096); // go past the first two lines of XML stuff
      for($i = 0; $i < $count; $i++) {
        $data = trim(@fgets($fh, 4096));
        if(eregi( "<weblog name=\"([ -_.;|&'a-z0-9]*)\" url=\"http://([-_./?=~a-z0-9]*)\"", $data, $var)) {
          $site = $var[1]; $url = $var[2];
          $updated_sites[$site] = $url;
        }
        if(feof($fh)) // if it reaches the end of the file, quit
          break;
      }

      foreach($updated_sites as $site=>$url) {
        if( ($site != '0') && ($url != '') ) {
          // modify this line to set how the list is displayed
          $list .= "<a href=\"http://$url\">$site</a><br />\n";
        } else {
          echo "you suck! -- $site -- $url\n";
        }
      }

      // modify these two to set the header/footer of the list
      $list_header = "<p><b>updated weblogs</b><br />\n";
      $list_footer = "<small>via <a href=\"http://www.weblogs.com\">Weblogs.com</a></small></p>\n\n";
      return $list_header . $list . $list_footer;
    }
  }
}
?>