<?php
/*
Supasite - web based PHP/mySQL/XML content management tool
Copyright (C) 2001 - Rick Olson (rick@techno-weenie.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

SCRIPT NAME:  site_news.php (frontend)
DESC:  grabs news and displays it in html
*/

require_once("$supa[db_path]/$supa[db]_news.php"); # loads the backend functions

### given the page number, display the news ###
function news_getNewsByPage($page_num) {
  global $site;
  # get the values for the title and content
  if($posts = data_getNews($page_num, 'page', $site[newsage])) {
    $GLOBALS['posted'] = array();
    while(list($null, $res) = each($posts)) {
      $content .= news_printNews($res);
    }
    return $content;
  } else {
    return common_status("No results returned.");
  }
}

function news_getNewsByID($news_id, $mode) {
  if($news = data_getNews($news_id, 'id')) {
    list($null, $fields) = each($news);

    ### add the comment if applicable
    if(($mode == 'addcomment') && ($GLOBALS['submit'])) {
      global $HTTP_POST_VARS;
      comment_add($fields[n_id], $HTTP_POST_VARS[name], $HTTP_POST_VARS[www], $HTTP_POST_VARS[comment], $HTTP_POST_VARS[cookie]);
      $fields[comments]++;
    }
    $GLOBALS['posted'] = array();
    $content .= news_printNews($fields);
    $content .= comment_print($fields[n_id], $fields[comments], $fields[views], $news[num2]);

    ### show the addcomment form
    if(($mode == 'addcomment') && (!$submit))
      $content .= comment_addForm($fields[n_id]);
    elseif($mode == 'addcomment')
      $content .= common_status('Comment posted!');

    return $content;

    # else, if you get no results back
  } else {
    return common_status("Bad news post id.");
  }
}

### given a topic, show recent posts for that topic
function news_getNewsByTopic($topic) {
  global $site;

  if($posts = backend_getNewsByTopic($topic)) {
    $GLOBALS['posted'] = array();
    foreach($posts as $row) {
      $news .= news_printNews($row);
    }
    $topic = str_replace("_", " ", $topic);
    return common_status("Viewing last $site[newsage] posts in [ $topic ].").$news;
  } else {
    ### no results returned ###
    return common_status("No results returned for [ $topic ].").news_getNewsByPage(0);
  }
}

### given the month and the year, show the posts for that month ###
function news_getNewsArchives($year, $month, $day) {
  if($posts = backend_getNewsArchives($month, $year, $day)) {
    $GLOBALS['posted'] = array();
    while(list($null, $row) = each($posts)) {
      $archives .= news_printNews($row);
    }
    return news_printArcArrows($year, $month).$archives;
  } else {
    return news_printArcArrows($year, $month).news_printArcIndex("No news items returned.");
  }
}

### given the result array of the list news query, return the news results in HTML
function news_printNews($result_array) {
  global $templates, $site, $supa;
  $template = $templates->return_templates();
  $posted = &$GLOBALS['posted'];
  foreach($result_array as $k => $v) {
    $$k = $v;
  }

  $script_name = "$supa[web_path]/$site[news_script]";

  $post = common_outputEntry($post);
  $subject = common_outputEntry($subject);
  $view_url = "$supa[web_path]/$site[news_script]/view/$n_id";
  $topic_name = "<a href=\"$script_name/topic/".str_replace(" ", "_", $topic)."\">$topic</a>";
  $viewcomment_url = "$script_name/viewcomment/$n_id";

  $icon_size = @getImageSize($icon);
  $topic_icon = "<img src=\"$icon\" $icon_size[3] alt=\"$topic img\" />";

  # store date in $return
  if(!$posted[$date_str]) {
    $posted[$date_str] = 1;

    $datelink = "<a class=\"datelink\" href=\"$supa[web_path]/$site[news_script]/archives/$date_str\">$date</a>";
    $return = $template[date]."\n";
    $search = array("%date%", '%datelink%');
    $replace = array("$date", $datelink);
    $search = site_pushVars($search, 'search');
    $replace = site_pushVars($replace);
    for($i = 0; $i < count($search); $i++) {
      $return = str_replace($search[$i], $replace[$i], $return);
    }
  }

  # store all posts in $temp first
  $search = array("%n_id%", "%subject%", "%topic_name%", "%post%", "%view_url%", "%username%", "%email%", "%comments%", "%topic_icon%");
  $replace = array("$n_id", "$subject", "$topic_name", "$post", "$view_url", "$username", "$email", "$comments", "$topic_icon");
  $search = site_pushVars($search, 'search');
  $replace = site_pushVars($replace);

  $temp = "$template[news]\n\n";

  for($i = 0; $i < count($search); $i++) {
    $temp = str_replace($search[$i], $replace[$i], $temp);
  }

  # now merge $temp with $return
  return trim($return)."\n".trim($temp)."\n\n";
}

### print the index of the archives
function news_printArcIndex($msg = '') {
  global $supa, $site;
  if($msg != '') {
    $content = common_status($msg);
  }
  $res_arr = backend_returnMonthInfo();
  foreach($res_arr as $row) {
    $year = $row[year]; $mon = $row[month]; $monthname = $row[monthname];
    $temp_url = "$supa[web_path]/$site[news_script]/archives/$year-$mon";

    if(!$posted[$year])
      $posted[$year] = true;
      $archive[$year]['year'] = "<p class=\"archiveIndex\">$year</p>\n";

    if(!$posted["$year-$mon"]) {
      $archive[$year]['month'] .= "<a href=\"$temp_url\">$monthname</a><br />\n";
      $posted["$year-$mon"] = true;
    }
  }

  foreach($archive as $k=>$v) {
    $content .= $archive[$k][year];
    $content .= "<p class=\"status\">".$archive[$k][month]."</p>\n\n";
  }

  return trim($content);
}

### print the arrows ###
function news_printArrows() {
  global $news, $supa, $site, $templates, $is_caching;
  if($is_caching == 'main news') ### if caching main news, set mode to page ###
    $news[mode] = 'page';
  if(is_array($news)) {  ### otherwise if $news is not even set, don't bother with the news arrows ###
    $template = $templates->return_templates();

    $count = data_countPosts($site[newsage]);

    ### decide if it's necessary to make a $next_string
    ### and fill the %units% and %count_string% info
    switch($news[mode]) {
      case 'page':
        # if the page number is < than the total pages,
        if(($news[num] < $count[last_page]) && ($count[posts] > $site[newsage])) { $next = 1; }
        $units = "$site[newsage] entries";

        # increment both by one because not everyone counts like a programmer (0, 1, 2, 3...)
        $current = $news[num] + 1;
        $last = $count[last_page] + 1;
        $count_string = "page $current of $last.";
      break;

      case 'view':
      case 'addcomment':
        # if the current post id is < last ID...
        if($news[num] < $count[last_id]) { $next = 1; }
        $units = "id";
        $count_string = "news post $news[num]";
      break;

      default:
        $news[mode] = 0;
    }

    ### make the $prev_string... make it a link if it has to be
    $prev_string = $template[prev];

    $search = array("%units%");
    $replace = array($units);
    $search = site_pushVars($search, 'search');
    $replace = site_pushVars($replace);
    for($i = 0; $i < count($search); $i++) {
      $prev_string = str_replace($search[$i], $replace[$i], $prev_string);
    }

    if(($news[num] > 0) && ($news[mode])) { # dont bother making a previous arrow for the -1 page
      $prev = 1;
      $prev_num = $news[num] - 1;
      $prev_url = "$supa[web_path]/$site[news_script]/$news[mode]/$prev_num";

      $prev_string = "<a href=\"$prev_url\">$prev_string</a>";
    }

    ### make the $next_string
    $search = array("%units%");
    $replace = array($units);
    $search = site_pushVars($search, 'search');
    $replace = site_pushVars($replace);

    $next_string = $template[next];

    for($i = 0; $i < count($search); $i++) {
      $next_string = str_replace($search[$i], $replace[$i], $next_string);
    }

    if($next) { # check to see if a next arrow is needed
      $next_num = $news[num] + 1;
      $next_url = "$supa[web_path]/$site[news_script]/$news[mode]/$next_num";
      $next_string = "<a href=\"$next_url\">$next_string</a>";
    }

    ### make the page count string

    $search = array("%count_string%");
    $replace = array($count_string);
    $search = site_pushVars($search, 'search');
    $replace = site_pushVars($replace);

    $str = $template[arrow];
    for($i = 0; $i < count($search); $i++) {
      $str = str_replace($search[$i], $replace[$i], $str);
    }

    if($str != '')
      $str .= "<br />\n";

    ### now, print the whole thing out
    if( ($next) || ($prev) )
      return trim("<p class=\"arrow\">$str$prev_string | $next_string</p>\n\n");
  }
}

### print news arrows when viewing by month ###
function news_printArcArrows($arc_year, $arc_month) {
  global $supa, $site;

  $current_month = "$arc_year-$arc_month";
  $monthname = common_getMonthName($arc_month);
  ### getting first/last months
  $res_array = array_reverse(backend_returnMonthInfo());
  list($null, $row) = each($res_array);
  $months['first'] = "$row[year]-$row[month]";
  $months['last'] = date("Y-m");

# make the arrows
  if($current_month > $months[first]) # decides whether there's a previous arrow
    $months['prev'] = true;

  if($current_month < $months[last]) # decides whether there's a next arrow
    $months['next'] = true;

  ### making prev arrows
  if($months['prev']) {
    $prev_month = $arc_month - 1;
    $prev_year = $arc_year;
    if($prev_month < 1) {
      $prev_year = $arc_year - 1;
      $prev_month = '12';
    }

    if(strlen($prev_month) == 1)
      $prev_month = '0'.$prev_month;

    $prev_URL = "$supa[web_path]/$site[news_script]/archives/$prev_year-$prev_month";
    $prev_arrows = "<a href=\"$prev_URL\">&lt;-- ".common_getMonthName($prev_month)."</a> |";
  }

  ### making next arrows
  if($months['next']) {
    $next_month = $arc_month + 1;
    $next_year = $arc_year;
    if($next_month > 12) {
      $next_year = $arc_year + 1;
      $next_month = '01';
    }

    if(strlen($next_month) == 1)
      $next_month = '0'.$next_month;

    $next_URL = "$supa[web_path]/$site[news_script]/archives/$next_year-$next_month";
    $next_arrows = "| <a href=\"$next_URL\">".common_getMonthName($next_month)." --&gt;</a>";
  }

  return trim("<p class=\"arrow\">$prev_arrows viewing $monthname $arc_year $next_arrows</p>\n\n");
}

### returns archive list for the bottom of a news page ###
function news_getArcIndexBottom() {
  global $supa, $templates, $site;
  $template = $templates->return_templates();

  ### create archive index list
  $res_array = backend_returnMonthInfo();

  foreach($res_array as $row) {
    # uses datestamp like 20010121, Sunday, Jan 21, 2001
    $year = $row[year]; $mon = $row[month]; $monthname = $row[monthname];
    $temp_url = "$supa[web_path]/$site[news_script]/archives/$year-$mon";
    $monthname = "<a href=\"$temp_url\">$monthname</a> ";

    # get current year and last year
    if(!$array['current_year']) {
      $array['current_year'] = $year;
      $array['last_year'] = $year - 1;
    }

    if(!$array['current_month'])
      $array['current_month'] = $monthname;

    # get current_year_months and last_year_months
    if(($year == $array[current_year]) && (!$arc[$mon]))
      $array['current_year_months'] .= $monthname;
    elseif(($year == $array[last_year]) && (!$arc[$mon]))
      $array['last_year_months'] .= $monthname;

    # check year
    if(!$arc[$year])
      $arc[$year] = true;

    # check month
    if(!$arc[$mon])
      $arc[$mon] = true;
  }

  $search = array('%current_month%', '%current_year%', '%current_year_months%', '%last_year%', '%last_year_months%');
  $replace = array($array['current_month'], $array['current_year'], $array['current_year_months'], $array['last_year'], $array['last_year_months']);
  $search = site_pushVars($search, 'search');
  $replace = site_pushVars($replace);

  # variables are all declared... now fill the template
  $return = $template[archiveList];
  for($i = 0; $i < count($search); $i++) {
    $return = str_replace($search[$i], $replace[$i], $return);
  }

  $arc = trim("<p class=\"archiveList\">[ <a href=\"$supa[web_path]/$site[news_script]/archives/\">view archives</a> ]<br />\n".$return."</p>\n\n");
  return $arc;
}

?>