<?php
/*
Supasite - web based PHP/mySQL/XML content management tool
Copyright (C) 2001 - Rick Olson (rick@techno-weenie.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

/* transform.php
 * Performs an XSL transformation on a TWML to a different XML format
 */

require_once("supasite/config.php");

/* USAGE:
 *   Access this script with the following arguments:
 *     http://[domain]/transform.php?twml=[input filename]&xsl=[XSL filename]
 *     twml defaults to newsfeed.twml and xsl defaults to twml-rss092.xsl
 *     you may omit the extensions and the 'twml-'  in front of the xsl filename
 *     ie:  http://whatever.com/transform.php?twml=newsfeed&xsl=rss092
 *   It takes the [input filename] and performs an XSL transformation using the XSL file.
 *   It finds these files in the files directory, specified below by $default_path
 */

if(!$twml) {
  # set default to the newsfeed file #
  $twml = 'newsfeed';
}

if(!$xsl) {
  # set default to twml-rss092.xsl #
  $xsl = 'rss092';
}

/* setting default paths */
$default_path = "$supa[include_path]/files/";
$twml = "$default_path$twml.twml";
$xsl = $default_path."twml-$xsl.xsl";

header("Content-Type: text/xml");
echo xsl_transform($twml, $xsl);

### DECLARE FUNCTIONS ###
function xsl_transform($xml, $xsl) {
  ### open XML and XSL files ###
  $xml_handle = fopen($xml, "r") or die("Can't open XML file");
  $xsl_handle = fopen($xsl, "r") or die("Can't open XSL file");

  ### get the contents ###
  $xml_content = fread($xml_handle, filesize($xml));
  $xsl_content = fread($xsl_handle, filesize($xsl));

  ### process files ###
  $handle = xslt_create() or die("Can't create XSLT handle.");
  xslt_process($xsl_content, $xml_content, $result);

  @xslt_free($handle);

  return $result;
}
?>