<?php
/*
Supasite - web based PHP/mySQL/XML content management tool
Copyright (C) 2001 - Rick

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

SUPASITE UPGRADE SCRIPT

*/

// starting now, this script will be easier to modify for new versions...
$old_ver = '1.22';
$new_ver = '1.23';

// array containing all queries to be run
$queries = array(
  "UPDATE settings SET param = 'modules_databaseFilename' WHERE param = 'modules_modsFilename';",
  "DELETE FROM settings WHERE param = 'modules_mods';",
  "INSERT INTO settings (type, param, value) VALUES ('config', 'ping', '0');",
  "INSERT INTO settings (type, param, value) VALUES ('modules', 'modules_database', 'manage_modules:1::backup:1::restore:1');",
  "INSERT INTO settings (type, param, value) VALUES ('modules', 'modules_databaseFilename', 'admin_mods.php');"
                );

// function that tests if upgrade is necessary... return either true or false
function test() {
  global $db;
  $res = $db->get_results("SELECT value FROM settings WHERE param = 'ping';");
  if(count($res) > 0)
    return 1;
  else
    return 0;
}

// function that performs special upgrade tasks
function special_upgrade() {
  global $db;
  $res = $db->get_results("SELECT value FROM settings WHERE param = 'modules';");
  $value = $db->next_result(&$res);
  $new_value = str_replace("Mods:0", "Database:1", $value[value]);
  $db->run_query("UPDATE settings SET value = '$new_value' WHERE param = 'modules';");
}

### start the HTML for the page ###
echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Strict//EN\" \"http://www.w3.org/TR/html4/strict.dtd\">\n\n";
echo "<html>\n<head>\n\t<title>Supasite Installation</title>\n</head>\n\n";
echo "<body>\n\n";

#***PUT YOUR SERVER PATH HERE***
require_once("supasite/config.php");

echo "<div>\n\n"; # end the 'error' DIV
echo "<form action=\"$PHP_SELF\" METHOD=\"POST\">\n\n";

if(!$HTTP_POST_VARS['submit']) {
?>
<p>This will modify some of the internal database settings.  No actual news data will be affected.</p>
<pre>
<?
foreach($queries as $query)
  echo $query."\n";
?>
</pre>
<p><b>Username</b>: <input type="text\" name="username" /></p>
<p><b>Password</b>: <input type="password" name="password" /></p>
<p><input type="submit" name="submit" value="Log In" /></p>
<?
} else {
  require_once("$supa[db_path]/$supa[db]_auth.php");
  /* check if username/password is GOOD */
  $username = $HTTP_POST_VARS['username'];
  $password = md5($HTTP_POST_VARS['password']);
  if(!auth_login($username, $password)) {

    die("Bad Login...");

  } else {

    if(!test()) {

      /* upgrading! */
      echo common_status("Converting Supasite $old_ver tables to $new_ver...");
      foreach($queries as $query)
        $db->run_query($query);
      special_upgrade();
      echo common_status("Supasite Upgrade Complete!");

    } else {

      echo common_status("Supasite upgrade to $new_ver not necessary...");

    }
  }
}

echo "</form>\n\n</div>\n</body>\n</html>";
?>